/* Egoboo - egoboo.h
 * Disgusting, hairy, way too monolithic header file for the whole darn
 * project.  In severe need of cleaning up.  Venture here with extreme
 * caution, and bring one of those canaries with you to make sure you
 * don't run out of oxygen.
 */

/*
    This file is part of Egoboo.

    Egoboo is free software: you can redistribute it and/or modify it
    under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    Egoboo is distributed in the hope that it will be useful, but
    WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with Egoboo.  If not, see <http://www.gnu.org/licenses/>.
*/

#ifndef _EGOBOO_H_
#define _EGOBOO_H_

/* Typedefs for various platforms */
#include "egobootypedef.h"

#include <stdlib.h>
#include <stdarg.h>
#include <stdio.h>
#include <string.h>
#include <fcntl.h>
#include <ctype.h>
#include <time.h>
#include <math.h>

#include <SDL_opengl.h>

#include "proto.h"
#include "gltexture.h" /* OpenGL texture loader */
#include "mathstuff.h" /* vector and matrix math */
#include "configfile.h"
#include "Md2.h"

typedef struct glvertex_t
{
  GLfloat x, y, z, w;
  GLfloat nx, ny, nz;
  GLfloat r, g, b, a;
  Uint32 color; // should replace r,g,b,a and be called by glColor4ubv
  GLfloat s, t; // u and v in D3D I guess
} GLVERTEX;

// The following magic allows this include to work in multiple files
#ifdef DECLARE_GLOBALS
#define EXTERN
#define EQ(x) =x;
#else
#define EXTERN extern
#define EQ(x)
#endif

EXTERN char					VERSION[] EQ("2.7.5");  // Version of the game
EXTERN bool_t    gamepaused EQ(bfalse); //Is the game paused?
EXTERN bool_t    startpause EQ(btrue);  //Pause button avalible?

#define NETREFRESH          1000                    // Every second
#define NONETWORK           numservice              //
#define MAXMODULE           100                     // Number of modules
#define TITLESIZE           128                     // Size of a title image
#define MAXSEQUENCE         256                     // Number of tracks in sequence
#define MAXIMPORT           (32*9)                  // Number of subdirs in IMPORT directory

#define NOSPARKLE           255
#define ANYTIME             255                     // Code for respawnvalid...

#define SIZETIME            50                      // Time it takes to resize a character
#define WATCHMIN            .01                     //

#define PRTLEVELFIX         20                      // Fix for shooting over cliffs
#define PACKDELAY           25                      // Time before inventory rotate again
#define GRABDELAY           25                      // Time before grab again
#define NOSKINOVERRIDE      -1                      // For import

#define PITDEPTH            -30                     // Depth to kill character
#define PITNOSOUND          -256                    // Stop sound at bottom of pits...

EXTERN Uint16  endtextindex[8];

/*
#define MAXSPEECH           6
#define SPEECHMOVE          0
#define SPEECHMOVEALT       1
#define SPEECHATTACK        2
#define SPEECHASSIST        3
#define SPEECHTERRAIN       4
#define SPEECHSELECT        5
*/

#define EXPKEEP 0.85                                // Experience to keep when respawning

#define DISMOUNTZVEL        16
#define DISMOUNTZVELFLY     4

#define EDGE                128                     // Camera bounds
#define FARTRACK            1200                    // For outside modules...
#define EDGETRACK           800                     // Camtrack bounds

#define MAXNUMINPACK        6                       // Max number of items to carry in pack

#define NOHIDE              127                     // Don't hide

#define THROWFIX            30.0                    // To correct thrown velocities
#define MINTHROWVELOCITY    15.0                    //
#define MAXTHROWVELOCITY    45.0                    //


#define LOWSTAT             256                     // Worst...
#define PERFECTSTAT         (75*256)                // Perfect...
#define PERFECTBIG          (127*256)               // Perfect life or mana...
#define HIGHSTAT            (99*256)                // Absolute MAX strength...
#define MINDAMAGE           256                     // Minimum damage for hurt animation
#define MSGDISTANCE         2000                    // Range for SendMessageNear

#define DAMFXNONE           0                       // Damage effects
#define DAMFXARMO           1                       // Armor piercing
#define DAMFXBLOC           2                       // Cannot be blocked by shield
#define DAMFXARRO           4                       // Only hurts the one it's attached to
#define DAMFXTURN           8                       // Turn to attached direction
#define DAMFXTIME           16                      //


#define ULTRABLOODY         2                       // This makes any damage draw blud
#define SPELLBOOK           127                     // The spellbook model TODO: change this badly thing

#define GENFEMALE           0                       // Gender
#define GENMALE             1                       //
#define GENOTHER            2                       //
#define GENRANDOM           3                       //

#define RETURNAND           63                      // Return mana every so often
#define MANARETURNSHIFT     4                       //
#define HURTDAMAGE          (1*256)                 //

#define MAXPASS             256                     // Maximum number of passages ( mul 32 )
#define MAXSTAT             16                      // Maximum status displays
#define MAXLOCO             3                       // Maximum number of local players

#define JOYBUTTON           8                       // Maximum number of joystick buttons
#define MOUSEBUTTON         4
#define MAXMESSAGE          6                       // Number of messages
#define MAXTOTALMESSAGE     1024                    //
#define MESSAGESIZE         80                      //
#define MESSAGEBUFFERSIZE   (MAXTOTALMESSAGE*40)
#define MESSAGETIME         200                     // Time to keep the message alive
#define TABAND              31                      // Tab size

#define MADFXINVICTUS       1                       // I Invincible
#define MADFXACTLEFT        2                       // AL Activate left item
#define MADFXACTRIGHT       4                       // AR Activate right item
#define MADFXGRABLEFT       8                       // GL GO Grab left/Grab only item
#define MADFXGRABRIGHT      16                      // GR Grab right item
#define MADFXDROPLEFT       32                      // DL DO Drop left/Drop only item
#define MADFXDROPRIGHT      64                      // DR Drop right item
#define MADFXSTOP           128                     // S Stop movement
#define MADFXFOOTFALL       256                     // F Footfall sound
#define MADFXCHARLEFT       512                     // CL Grab left/Grab only character
#define MADFXCHARRIGHT      1024                    // CR Grab right character
#define MADFXPOOF           2048                    // P Poof


#define GRABSIZE            90.0                    // Grab tolerance

#define LIPDA               0                       // For smooth transitions 'tween
#define LIPWA               1                       //   walking rates
#define LIPWB               2                       //
#define LIPWC               3                       //

#define NULLICON            0                       // Empty hand image

#define MAXPRTPIP           1024                    // Particle templates

typedef enum prtpip_t
{
  PRTPIP_COIN_001 = 0,                  // Coins are the first particles loaded
  PRTPIP_COIN_005,                      //
  PRTPIP_COIN_025,                      //
  PRTPIP_COIN_100,                      //
  PRTPIP_WEATHER_1,                     // Weather particles
  PRTPIP_WEATHER_2,                     // Weather particle finish
  PRTPIP_SPLASH,                        // Water effects are next
  PRTPIP_RIPPLE,                        //
  PRTPIP_DEFEND,                        // Defend particle
  PRTPIP_PEROBJECT_COUNT                //
} PRTPIP;

#define RIPPLEAND           15                      // How often ripples spawn
#define RIPPLETOLERANCE     60                      // For deep water
#define SPLASHTOLERANCE     10                      //
#define CLOSETOLERANCE      2                       // For closing doors


#define MAXDAMAGETYPE       8                       // Damage types
#define DAMAGENULL          255                     //
#define DAMAGESLASH         0                       //
#define DAMAGECRUSH         1                       //
#define DAMAGEPOKE          2                       //
#define DAMAGEHOLY          3                       // (Most invert Holy damage )
#define DAMAGEEVIL          4                       //
#define DAMAGEFIRE          5                       //
#define DAMAGEICE           6                       //
#define DAMAGEZAP           7                       //
#define DAMAGECHARGE        8                       // 0000x000 Converts damage to mana
#define DAMAGEINVERT        4                       // 00000x00 Makes damage heal
#define DAMAGESHIFT         3                       // 000000xx Resistance ( 1 is common )
#define DAMAGETILETIME      32                      // Invincibility time
#define DAMAGETIME          16                      // Invincibility time
#define DEFENDTIME          16                      // Invincibility time
#define DROPXYVEL           8                       //
#define DROPZVEL            7                       //
#define JUMPATTACKVEL       -2                      //
#define WATERJUMP           12                      //

#define MAXSTOR             8                       // Storage data
#define STORAND             7                       //

#define MAXWAY              8                       // Waypoints
#define WAYTHRESH           128                     // Threshold for reaching waypoint
#define AISMAXCOMPILESIZE   (128*4096/4)            // For parsing AI scripts
#define MAXLINESIZE         1024                    //
#define MAXAI               129                     //
#define MAXCODE             1024                    // Number of lines in AICODES.TXT
#define MAXCODENAMESIZE     64                      //

#define MAXCAPNAMESIZE      32                      // Character class names
#define MAXLEVEL            6                       // Levels 0-5
#define MAXEXPERIENCETYPE   8                       // Number of ways to get experience
#define MAXIDSZ             6                       // ID strings per character
#define IDSZNONE            MAKE_IDSZ("NONE")       // [NONE]
#define IDSZPARENT          0                       // Parent index
#define IDSZTYPE            1                       // Self index
#define IDSZSKILL           2                       // Skill index
#define IDSZSPECIAL         3                       // Special index
#define IDSZHATE            4                       // Hate index
#define IDSZVULNERABILITY   5                       // Vulnerability index


#define XPFINDSECRET        0                       // Finding a secret
#define XPWINQUEST          1                       // Beating a module or a subquest
#define XPUSEDUNKOWN        2                       // Used an unknown item
#define XPKILLENEMY         3                       // Killed an enemy
#define XPKILLSLEEPY        4                       // Killed a sleeping enemy
#define XPKILLHATED         5                       // Killed a hated enemy
#define XPTEAMKILL          6                       // Team has killed an enemy
#define XPTALKGOOD          7                       // Talk good, er...  I mean well
#define XPDIRECT            255                     // No modification


#define MAXTEAM             27                      // Teams A-Z, +1 more for damage tiles
#define DAMAGETEAM          26                      // For damage tiles
#define EVILTEAM            4                       // E
#define GOODTEAM            6                       // G
#define NULLTEAM            13                      // N


#define NOACTION            0xffff                  // Action not valid for this character
#define MAXACTION           76                      // Number of action types
EXTERN char    cActionName[MAXACTION][2];                  // Two letter name code

#define TURNMODEVELOCITY    0                       // Character gets rotation from velocity
#define TURNMODEWATCH       1                       // For watch towers
#define TURNMODESPIN        2                       // For spinning objects
#define TURNMODEWATCHTARGET 3                       // For combat intensive AI
#define SPINRATE            200                     // How fast spinners spin
#define FLYDAMPEN           .001                    // Levelling rate for flyers

#define LATCHBUTTONNONE          0
#define LATCHBUTTONLEFT      (1<<0)                    // Character button presses
#define LATCHBUTTONRIGHT     (1<<1)                    //
#define LATCHBUTTONJUMP      (1<<2)                    //
#define LATCHBUTTONALTLEFT   (1<<3)                    // ( Alts are for grab/drop )
#define LATCHBUTTONALTRIGHT  (1<<4)                    //
#define LATCHBUTTONPACKLEFT  (1<<5)                    // ( Packs are for inventory cycle )
#define LATCHBUTTONPACKRIGHT (1<<6)                    //
#define LATCHBUTTONRESPAWN   (1<<7)                    //

#define JUMPINFINITE        255                     // Flying character
#define JUMPDELAY           20                      // Time between jumps
#define JUMPTOLERANCE       20                      // Distance above ground to be jumping
#define SLIDETOLERANCE      10                      // Stick to ground better
#define PLATTOLERANCE       50                      // Platform tolerance...
#define PLATADD             -10                     // Height add...
#define PLATASCEND          .10                     // Ascension rate
#define PLATKEEP            (1.0f-PLATASCEND)       // Retention rate

#define MAPID 0x4470614d                      // The string... MapD

#define RAISE 12 //25                               // Helps correct z level
#define SHADOWRAISE 5                               //
#define DAMAGERAISE 25                              //

#define MAXWATERLAYER 2                             // Maximum water layers
#define MAXWATERFRAME 512                           // Maximum number of wave frames
#define WATERFRAMEAND (MAXWATERFRAME-1)             //
#define WATERPOINTS 4                               // Points in a water fan
#define WATERMODE 4                                 // Ummm...  For making it work, yeah...

#define DONTFLASH 255                               //

#define FOV                             60          // Field of view
#define ROTMESHTOPSIDE                  55          // For figuring out what to draw
#define ROTMESHBOTTOMSIDE               65          //
#define ROTMESHUP                       40 //35          //
#define ROTMESHDOWN                     60          //
EXTERN int rotmeshtopside;                                 // The ones that get used
EXTERN int rotmeshbottomside;                              //
EXTERN int rotmeshup;                                      //
EXTERN int rotmeshdown;                                    //

#define NUMFONTX                        16          // Number of fonts in the bitmap
#define NUMFONTY                        6           //
#define NUMFONT                         (NUMFONTX*NUMFONTY)
#define FONTADD                         4           // Gap between letters
#define NUMBAR                          6           // Number of status bars
#define TABX                            32//16      // Size of little name tag on the bar
#define BARX                            112//216         // Size of bar
#define BARY                            16//8           //
#define NUMTICK                         10//50          // Number of ticks per row
#define TICKX                           8//4           // X size of each tick
#define MAXTICK                         (NUMTICK*5) // Max number of ticks to draw

#define TURNSPD                         .01         // Cutoff for turning or same direction
#define CAMKEYTURN                      5          // Keyboard camera rotation
#define CAMJOYTURN                      5         // Joystick camera rotation


// Multi cam
#define MINZOOM                         500         // Camera distance
#define MAXZOOM                         600         //
#define MINZADD                         800         // Camera height
#define MAXZADD                         1500  //1000
#define MINUPDOWN                       (.18*PI)//(.24*PI)    // Camera updown angle
#define MAXUPDOWN                       (.18*PI)


#define MD2START                        0x32504449  // MD2 files start with these four bytes
#define MD2MAXLOADSIZE                  (512*1024)  // Don't load any models bigger than 512k
#define MD2LIGHTINDICES                 163//162    // MD2's store vertices as x,y,z,normal
#define EQUALLIGHTINDEX                 162         // I added an extra index to do the
// spikey mace...

#define MAXTEXTURE                      512         // Max number of textures
#define MAXVERTICES                     768//512    // Max number of points in a model
#define MAXCOMMAND                      256         // Max number of commands
#define MAXCOMMANDSIZE                  64          // Max number of points in a command
#define MAXCOMMANDENTRIES               512//256         // Max entries in a command list ( trigs )
#define MAXMODEL                        256         // Max number of models
#define MAXEVE                          MAXMODEL    // One enchant type per model
#define MAXENCHANT                      128         // Number of enchantments
#define MAXFRAME                        (128*32)    // Max number of frames in all models
#define MAXCHR                          350         // Max number of characters
#define MAXLIGHTLEVEL                   16          // Number of premade light intensities
#define MAXSPEKLEVEL                    16          // Number of premade specularities
#define MAXLIGHTROTATION                256         // Number of premade light maps
#define MAXPRT                          512         // Max number of particles
#define MAXDYNA                         8           // Number of dynamic lights
#define MAXDYNADIST                     2700        // Leeway for offscreen lights
#define GRIPVERTICES                    8           // Each model has 8 grip vertices
#define GRIPRIGHT                       8           // Right weapon grip starts 8 from last
#define GRIPLEFT                        4           // Left weapon grip starts 4 from last
#define GRIPONLY                        4           // Only weapon grip starts 4 from last
#define SPAWNORIGIN                     0           // Center for spawn attachments
#define SPAWNLAST                       1           // Position for spawn attachments
#define INVENTORY                       0           //

#define CHOPPERMODEL                    32          //
#define MAXSECTION                      4           // T-wi-n-k...  Most of 4 sections
#define MAXCHOP                         (MAXMODEL*CHOPPERMODEL)
#define CHOPSIZE                        8
#define CHOPDATACHUNK                   (MAXCHOP*CHOPSIZE)

#define MAXMESHFAN                      (512*512)   // Terrain mesh size
#define MAXMESHSIZEY                    1024        // Max fans in y direction
#define BYTESFOREACHVERTEX              14          // 14 bytes each
#define MAXMESHVERTICES                 16          // Fansquare vertices
#define MAXMESHTYPE                     64          // Number of fansquare command types
#define MAXMESHCOMMAND                  4           // Draw up to 4 fans
#define MAXMESHCOMMANDENTRIES           32          // Fansquare command list size
#define MAXMESHCOMMANDSIZE              32          // Max trigs in each command
#define MAXTILETYPE                     256         // Max number of tile images
#define MAXMESHRENDER                   1024        // Max number of tiles to draw
#define FANOFF                       ((Uint16)(-1)) // Don't draw the fansquare if tile = this
#define OFFEDGE                      ((Uint32)(-1)) // Character not on a fan ( maybe )

#define MESHFXREF                           0          // 0 This tile is drawn 1st
#define MESHFXSHA                       (1<<0)         // 0 This tile is drawn 2nd
#define MESHFXDRAWREF                   (1<<1)         // 1 Draw reflection of characters
#define MESHFXANIM                      (1<<2)         // 2 Animated tile ( 4 frame )
#define MESHFXWATER                     (1<<3)         // 3 Render water above surface ( Water details are set per module )
#define MESHFXWALL                      (1<<4)         // 4 Wall ( Passable by ghosts, particles )
#define MESHFXIMPASS                    (1<<5)         // 5 Impassable
#define MESHFXDAMAGE                    (1<<6)         // 6 Damage
#define MESHFXSLIPPY                    (1<<7)         // 7 Ice or normal


#define SLOPE                           800     // Slope increments for terrain normals
#define SLIDE                           .04         // Acceleration for steep hills
#define SLIDEFIX                        .08         // To make almost flat surfaces flat

#define PRTLIGHTSPRITE                  0           // Magic effect particle
#define PRTSOLIDSPRITE                  1           // Sprite particle
#define PRTALPHASPRITE                  2           // Smoke particle

/* SDL_GetTicks() always returns milli seconds */
#define TICKS_PER_SEC                   1000.0f


#define TARGETFPS                       30.0f
#define FRAMESKIP                       (TICKS_PER_SEC/TARGETFPS)    // 1000 tics per sec / 50 fps = 20 ticks per frame

#define EMULATEUPS                      50.0f
#define TARGETUPS                       30.0f
#define UPDATESCALE                     (EMULATEUPS/(stabilized_ups/stabilized_ups_weight))
#define UPDATESKIP                      (TICKS_PER_SEC/TARGETUPS)    // 1000 tics per sec / 50 fps = 20 ticks per frame
#define ONESECOND                       (TICKS_PER_SEC/UPDATESKIP)    // 1000 tics per sec / 20 ticks per frame = 50 fps

#define STOPBOUNCING                    0.5f         // To make objects stop bouncing
#define STOPBOUNCINGPART                1.0f         // To make particles stop bouncing

#define TRANSCOLOR                      0           // Transparent color
#define BORETIME                        (rand()&255)+120
#define CAREFULTIME                     50
#define REEL                            7600.0      // Dampen for melee knock back
#define REELBASE                        .35         //


EXTERN int animtileupdateand  EQ(7);                          // New tile every 7 frames
EXTERN Uint16 animtileframeand  EQ(3);                // Only 4 frames
EXTERN Uint16 animtilebaseand  EQ(0xfffc);            //
EXTERN Uint16 biganimtileframeand  EQ(7);             // For big tiles
EXTERN Uint16 biganimtilebaseand  EQ(0xfff8);         //
EXTERN float  animtileframefloat  EQ(0);                // Current frame
EXTERN Uint16 animtileframeadd  EQ(0);                // Current frame

EXTERN Uint16 bookicon  EQ(0);                        // The first book icon

#define NORTH 16384                                 // Character facings
#define SOUTH 49152                                 //
#define EAST 32768                                  //
#define WEST 0                                      //
#define FRONT 0                                     // Attack directions
#define BEHIND 32768                                //
#define LEFT 49152                                  //
#define RIGHT 16384                                 //


#define MAXXP    ((1<<30)-1)                               // Maximum experience (Sint32 32)
#define MAXMONEY 9999                                      // Maximum money
#define NOLEADER 65535                                     // If the team has no leader...
EXTERN bool_t teamhatesteam[MAXTEAM][MAXTEAM];     // Don't damage allies...
EXTERN Uint16 teammorale[MAXTEAM];                 // Number of characters on team
EXTERN Uint16 teamleader[MAXTEAM];                 // The leader of the team
EXTERN Uint16 teamsissy[MAXTEAM];                  // Whoever called for help last
EXTERN short damagetileparttype;
EXTERN short damagetilepartand;
EXTERN short damagetilesound;
EXTERN short damagetilesoundtime;
EXTERN int   damagetilemindistance;
#define TILESOUNDTIME 16
#define TILEREAFFIRMAND  3


//Minimap stuff
#define MAXBLIP		   32					//Max number of blips displayed on the map
EXTERN Uint16          numblip  EQ(0);
EXTERN Uint16          blipx[MAXBLIP];
EXTERN Uint16          blipy[MAXBLIP];
EXTERN Uint8           blipc[MAXBLIP];
EXTERN Uint8           mapon  EQ(bfalse);
EXTERN Uint8           youarehereon  EQ(bfalse);


EXTERN Uint8           timeron     EQ(bfalse);        // Game timer displayed?
EXTERN Uint32          timervalue  EQ(0);             // Timer time ( 50ths of a second )


EXTERN char            szfpstext[64]         EQ( {0} );
EXTERN Sint32          ups_clock             EQ(0);               // The number of ticks this second
EXTERN Uint32          ups_loops             EQ(0);               // The number of frames drawn this second
EXTERN float           stabilized_ups        EQ(TARGETUPS);
EXTERN float           stabilized_ups_weight EQ(1);
EXTERN Sint32          fps_clock             EQ(0);               // The number of ticks this second
EXTERN Uint32          fps_loops             EQ(0);               // The number of frames drawn this second
EXTERN float           stabilized_fps        EQ(TARGETFPS);
EXTERN float           stabilized_fps_weight EQ(1);

EXTERN Sint32          sttclock;                       // GetTickCount at start
EXTERN Sint32          allclock   EQ(0);               // The total number of ticks so far
EXTERN Sint32          lstclock   EQ(0);               // The last total of ticks so far
EXTERN Sint32          wldclock   EQ(0);               // The sync clock
EXTERN Uint32          wldframe   EQ(0);               // The number of frames that should have been drawn
EXTERN Uint32          allframe   EQ(0);               // The total number of frames drawn so far
EXTERN Uint8           statclock  EQ(0);              // For stat regeneration
EXTERN float           pitclock   EQ(0);               // For pit kills
EXTERN Uint8           pitskill   EQ(bfalse);            // Do they kill?

EXTERN Uint8           outofsync  EQ(0);   //Is this only for RTS? Can it be removed then?
EXTERN Uint8           parseerror EQ(0);      //Do we have an script error?



EXTERN bool_t                    gameActive  EQ(bfalse);         // Stay in game or quit to windows?
EXTERN bool_t                    ingameMenuActive EQ(bfalse);   // Is the in-game menu active?
EXTERN bool_t                    moduleActive  EQ(bfalse);       // Is the control loop still going?

EXTERN bool_t                    mouseon  EQ(btrue);                // Is the mouse alive?
EXTERN bool_t                    keyon  EQ(btrue);                  // Is the keyboard alive?
EXTERN bool_t                    joyaon  EQ(bfalse);                 // Is the holy joystick alive?
EXTERN bool_t                    joybon  EQ(bfalse);                 // Is the other joystick alive?
EXTERN bool_t                    serviceon  EQ(bfalse);          // Do I need to free the interface?
//EXTERN bool_t                    menuaneeded  EQ(bfalse);         // Give them MENUA?
//EXTERN bool_t                    menuactive  EQ(bfalse);         // Menu running?
EXTERN bool_t                    hostactive  EQ(bfalse);         // Hosting?
EXTERN bool_t                    readytostart;               // Ready to hit the Start Game button?
EXTERN bool_t                    waitingforplayers;          // Has everyone talked to the host?
EXTERN bool_t                    somelocalpladead;            // Has someone died?
EXTERN bool_t                    alllocalpladead;            // Has everyone died?
EXTERN bool_t                    respawnvalid;               // Can players respawn with Spacebar?
EXTERN bool_t                    respawnanytime;             // True if it's a small level...
EXTERN bool_t                    importvalid;                // Can it import?
EXTERN bool_t                    exportvalid;                // Can it export?
EXTERN bool_t                    netmessagemode;             // Input text from keyboard?
EXTERN bool_t                    nolocalplayers;             // Are there any local players?
EXTERN bool_t                    beatmodule;                 // Show Module Ended text?

#define TURNTIME 16
EXTERN Uint8           netmessagedelay;            // For slowing down input
EXTERN int                     netmessagewrite;            // The cursor position
EXTERN int                     netmessagewritemin;         // The starting cursor position
EXTERN char                    netmessage[MESSAGESIZE];    // The input message
EXTERN int                     importamount;               // Number of imports for this module
EXTERN int                     playeramount;               //
EXTERN Uint32            seed  EQ(0);                   // The module seed
EXTERN char                    pickedmodule[64];           // The module load name
EXTERN int                     pickedindex;                // The module index number
EXTERN int                     playersready;               // Number of players ready to start
EXTERN int                     playersloaded;              //

// JF - Added so that the video mode might be determined outside of the graphics code
extern SDL_Surface *displaySurface;

//Networking
EXTERN int                     localmachine  EQ(0);           // 0 is host, 1 is 1st remote, 2 is 2nd...
EXTERN int                     numimport;                  // Number of imports from this machine
EXTERN Uint8                   localcontrol[16];           // For local imports
EXTERN short                   localslot[16];              // For local imports

//Setup values
EXTERN float                   mousesense  EQ(2);             // Sensitivity threshold
EXTERN float                   mousesustain EQ(.9);           // Falloff rate for old movement
EXTERN float                   mousecover EQ(.1);             // For falloff
EXTERN int                     mousedx  EQ(0);                 // Mouse X movement counter
EXTERN int                     mousedy  EQ(0);                 // Mouse Y movement counter
EXTERN int                     mousex  EQ(0);                 // Mouse X movement counter
EXTERN int                     mousey  EQ(0);                 // Mouse Y movement counter
EXTERN Sint32                  mousez  EQ(0);                 // Mouse wheel movement counter
EXTERN int                     cursorx  EQ(0);                // Cursor position
EXTERN int                     cursory  EQ(0);                //
EXTERN float                   mouselatcholdx  EQ(0);         // For sustain
EXTERN float                   mouselatcholdy  EQ(0);         //
EXTERN Uint8                   mousebutton[MOUSEBUTTON];             // Mouse button states
EXTERN bool_t                    pressed EQ(0);                  //
EXTERN bool_t                    clicked EQ(0);                  //
EXTERN bool_t         pending_click EQ(0);
// EWWWW. GLOBALS ARE EVIL.

//Input Control
//PORT: Use sdlkeybuffer instead.
//EXTERN char                    keybuffer[256];             // Keyboard key states
//EXTERN char                    keypress[256];              // Keyboard new hits
EXTERN float                   joyax  EQ(0);                  // Joystick A
EXTERN float                   joyay  EQ(0);                  //
EXTERN Uint8           joyabutton[JOYBUTTON];      //
EXTERN float                   joybx  EQ(0);                  // Joystick B
EXTERN float                   joyby  EQ(0);                  //
EXTERN Uint8           joybbutton[JOYBUTTON];      //
EXTERN Uint8           msb, jab, jbb;              // Button masks


//Weather and water gfx
EXTERN Uint8     watershift  EQ(3);
EXTERN bool_t    weatheroverwater EQ(bfalse);         // Only spawn over water?
EXTERN int       weathertimereset EQ(10);            // Rate at which weather particles spawn
EXTERN float     weathertime EQ(0);                  // 0 is no weather
EXTERN int       weatherplayer;
EXTERN int       numwaterlayer EQ(0);                // Number of layers
EXTERN float     watersurfacelevel EQ(0);            // Surface level for water striders
EXTERN float     waterdouselevel EQ(0);              // Surface level for torches
EXTERN bool_t    waterlight EQ(0);                   // Is it light ( default is alpha )
EXTERN Uint8     waterspekstart EQ(128);             // Specular begins at which light value
EXTERN Uint8     waterspeklevel EQ(128);             // General specular amount (0-255)
EXTERN bool_t    wateriswater  EQ(btrue);            // Is it water?  ( Or lava... )
EXTERN Uint8     waterlightlevel[MAXWATERLAYER]; // General light amount (0-63)
EXTERN Uint8     waterlightadd[MAXWATERLAYER];   // Ambient light amount (0-63)
EXTERN float     waterlayerz[MAXWATERLAYER];     // Base height of water
EXTERN Uint8     waterlayeralpha[MAXWATERLAYER]; // Transparency
EXTERN float     waterlayeramp[MAXWATERLAYER];   // Amplitude of waves
EXTERN float     waterlayeru[MAXWATERLAYER];     // Coordinates of texture
EXTERN float     waterlayerv[MAXWATERLAYER];     //
EXTERN float     waterlayeruadd[MAXWATERLAYER];  // Texture movement
EXTERN float     waterlayervadd[MAXWATERLAYER];  //
EXTERN float     waterlayerzadd[MAXWATERLAYER][MAXWATERFRAME][WATERMODE][WATERPOINTS];
EXTERN Uint8     waterlayercolor[MAXWATERLAYER][MAXWATERFRAME][WATERMODE][WATERPOINTS];
EXTERN Uint16    waterlayerframe[MAXWATERLAYER]; // Frame
EXTERN Uint16    waterlayerframeadd[MAXWATERLAYER];      // Speed
EXTERN float     waterlayerdistx[MAXWATERLAYER];         // For distant backgrounds
EXTERN float     waterlayerdisty[MAXWATERLAYER];         //
EXTERN Uint32    waterspek[256];             // Specular highlights
EXTERN float     foregroundrepeat  EQ(1);       //
EXTERN float     backgroundrepeat  EQ(1);       //

// Global lighting stuff
EXTERN float                   lightspekx EQ(0);
EXTERN float                   lightspeky EQ(0);
EXTERN float                   lightspekz EQ(0);
EXTERN float                   lightspek  EQ(0);
EXTERN float                   lightambi  EQ(0);


//Fog stuff
EXTERN bool_t          fogon  EQ(bfalse);              // Do ground fog?
EXTERN float                   fogbottom  EQ(0.0);            //
EXTERN float                   fogtop  EQ(100);               //
EXTERN float                   fogdistance  EQ(100);          //
EXTERN Uint8           fogred  EQ(255);               //  Fog collour
EXTERN Uint8           foggrn  EQ(255);               //
EXTERN Uint8           fogblu  EQ(255);               //
EXTERN bool_t          fogaffectswater;

//Camera control stuff
EXTERN int                     camswing  EQ(0);               // Camera swingin'
EXTERN int                     camswingrate  EQ(0);           //
EXTERN float                   camswingamp  EQ(0);            //
EXTERN float                   camx  EQ(0);                   // Camera position
EXTERN float                   camy  EQ(1500);                //
EXTERN float                   camz  EQ(750);                 // 500-1000
EXTERN float                   camzoom  EQ(1000);             // Distance from the trackee
EXTERN float                   camtrackxvel;               // Change in trackee position
EXTERN float                   camtrackyvel;               //
EXTERN float                   camtrackzvel;               //
EXTERN float                   camcenterx;                 // Move character to side before tracking
EXTERN float                   camcentery;                 //
EXTERN float                   camtrackx;                  // Trackee position
EXTERN float                   camtracky;                  //
EXTERN float                   camtrackz;                  //
EXTERN float                   camtracklevel;              //
EXTERN float                   camzadd  EQ(800);              // Camera height above terrain
EXTERN float                   camzaddgoto  EQ(800);          // Desired z position
EXTERN float                   camzgoto  EQ(800);             //
EXTERN float                   camturnleftright  EQ((float)(-PI_OVER_FOUR));      // Camera rotations
EXTERN float                   camturnleftrightone  EQ((float)(-PI_OVER_FOUR) / (TWO_PI));
EXTERN Uint16          camturnleftrightshort  EQ(0);
EXTERN float                   camturnadd  EQ(0);             // Turning rate
EXTERN float                   camsustain  EQ(.80);           // Turning rate falloff
EXTERN float                   camturnupdown  EQ((float)(PI_OVER_FOUR));
EXTERN float                   camroll  EQ(0);                //
EXTERN float                   cornerx[4];                 // Render area corners
EXTERN float                   cornery[4];                 //
EXTERN int                     cornerlistlowtohighy[4];    // Ordered list
EXTERN int                     cornerlowx;                 // Render area extremes
EXTERN int                     cornerhighx;                //
EXTERN int                     cornerlowy;                 //
EXTERN int                     cornerhighy;                //
EXTERN int                     fontoffset;                 // Line up fonts from top of screen

/*OpenGL Textures*/
EXTERN  GLTexture       TxTexture[MAXTEXTURE];        /* All textures */
EXTERN  GLTexture       TxIcon[MAXTEXTURE+1];       /* icons */
EXTERN  GLTexture       TxTitleImage[MAXMODULE];      /* title images */
EXTERN  GLTexture       TxTrim;
EXTERN  GLTexture       TxTrimX;                                        /* trim */
EXTERN  GLTexture       TxTrimY;                                        /* trim */
EXTERN  GLTexture       TxFont;                                         /* font */
EXTERN  GLTexture       TxBars;                                         /* status bars */
EXTERN  GLTexture       TxBlip;                                         /* you are here texture */
EXTERN  GLTexture       TxMap;

//Particle Texture Types
typedef enum part_type
{
  PART_NORMAL,
  PART_SMOOTH,
  PART_FAST
} PART_TYPE;

//Texture filtering
typedef enum tx_filters_e
{
  TX_UNFILTERED,
  TX_LINEAR,
  TX_MIPMAP,
  TX_BILINEAR,
  TX_TRILINEAR_1,
  TX_TRILINEAR_2,
  TX_ANISOTROPIC
} TX_FILTERS;

//Anisotropic filtering - yay! :P
#define GL_TEXTURE_MAX_ANISOTROPY_EXT 0x84FE
#define GL_MAX_TEXTURE_MAX_ANISOTROPY_EXT 0x84FF
EXTERN float maxAnisotropy;          // Max anisotropic filterings (Between 1.00 and 16.00)
EXTERN int   userAnisotropy;           // Requested anisotropic level
EXTERN int   log2Anisotropy;                  // Max levels of anisotropy

EXTERN bool_t      video_mode_chaged EQ(bfalse);
EXTERN SDL_Rect ** video_mode_list EQ(NULL);

EXTERN GLMATRIX mWorld;           // World Matrix
EXTERN GLMATRIX mView;           // View Matrix
EXTERN GLMATRIX mViewSave;          //View Matrix initial state
EXTERN GLMATRIX mProjection;         //Projection Matrix


//Input player control
EXTERN int                     numloadplayer  EQ(0);
#define MAXLOADPLAYER		   100
EXTERN char                    loadplayername[MAXLOADPLAYER][MAXCAPNAMESIZE];
EXTERN char                    loadplayerdir[MAXLOADPLAYER][16];
EXTERN int                     nullicon  EQ(0);
EXTERN int                     keybicon  EQ(0);
EXTERN int                     mousicon  EQ(0);
EXTERN int                     joyaicon  EQ(0);
EXTERN int                     joybicon  EQ(0);
EXTERN int                     keybplayer  EQ(0);
EXTERN int                     mousplayer  EQ(0);
EXTERN int                     joyaplayer  EQ(0);
EXTERN int                     joybplayer  EQ(0);

//Interface stuff
#define TRIMX 640
#define TRIMY 480
EXTERN rect_t                    iconrect;                   // The 32x32 icon rectangle
EXTERN rect_t                    trimrect;                   // The menu trim rectangle
EXTERN SDL_Rect					 fontrect[NUMFONT];          // The font rectangles
EXTERN Uint8					 fontxspacing[NUMFONT];      // The spacing stuff
EXTERN Uint8					 fontyspacing;               //
EXTERN rect_t                    tabrect[NUMBAR];            // The tab rectangles
EXTERN rect_t                    barrect[NUMBAR];            // The bar rectangles
EXTERN rect_t                    bliprect[NUMBAR];           // The blip rectangles
EXTERN rect_t                    maprect;                    // The map rectangle
#define SPARKLESIZE 28
#define SPARKLEADD 2
#define MAPSIZE 64
#define BLIPSIZE 3

//Lightning effects
EXTERN int                     numdynalight;               // Number of dynamic lights
EXTERN int                     dynadistancetobeat;         // The number to beat
EXTERN int                     dynadistance[MAXDYNA];      // The distances
EXTERN float                   dynalightlistx[MAXDYNA];    // Light position
EXTERN float                   dynalightlisty[MAXDYNA];    //
EXTERN float                   dynalightlistz[MAXDYNA];    //
EXTERN float                   dynalightlevel[MAXDYNA];    // Light level
EXTERN float                   dynalightfalloff[MAXDYNA];  // Light falloff
EXTERN Uint8				   lightdirectionlookup[65536];// For lighting characters
EXTERN float                   spek_global[MAXLIGHTROTATION][MD2LIGHTINDICES];
EXTERN float                   spek_local[MAXLIGHTROTATION][MD2LIGHTINDICES];
EXTERN Uint8				   cLoadBuffer[MD2MAXLOADSIZE];// Where to put an MD2

EXTERN Uint32				   maplrtwist[256];            // For surface normal of mesh
EXTERN Uint32			     mapudtwist[256];            //
EXTERN float           normtwistx[256];            // For sliding down steep hills
EXTERN float           normtwisty[256];            //
EXTERN float           normtwistz[256];            //
EXTERN bool_t          flattwist[256];             //

//Camera stuff
#define TRACKXAREALOW     100
#define TRACKXAREAHIGH    180
#define TRACKYAREAMINLOW  320
#define TRACKYAREAMAXLOW  460
#define TRACKYAREAMINHIGH 460
#define TRACKYAREAMAXHIGH 600


//Character stuff
EXTERN int             numfreechr EQ(0);               // For allocation
EXTERN Uint16          freechrlist[MAXCHR];        //
EXTERN GLMATRIX        chrmatrix[MAXCHR];			// Character's matrix
EXTERN bool_t          chrmatrixvalid[MAXCHR];     // Did we make one yet?
EXTERN char            chrname[MAXCHR][MAXCAPNAMESIZE];  // Character name
EXTERN bool_t          chron[MAXCHR];              // Does it exist?
//EXTERN Uint8           chronold[MAXCHR];           // Network fix
EXTERN bool_t          chralive[MAXCHR];           // Is it alive?
//EXTERN bool_t          chrwaskilled[MAXCHR];       // Fix for network
EXTERN bool_t          chrinpack[MAXCHR];          // Is it in the inventory?
EXTERN Uint8           chrwasinpack[MAXCHR];       // Temporary thing...
EXTERN Uint16          chrnextinpack[MAXCHR];      // Link to the next item
EXTERN Uint8           chrnuminpack[MAXCHR];       // How many
EXTERN Uint8           chropenstuff[MAXCHR];       // Can it open chests/doors?
EXTERN Uint8           chrlifecolor[MAXCHR];       // Bar color
EXTERN Uint8           chrsparkle[MAXCHR];         // Sparkle color or 0 for off
EXTERN Sint16            chrlife[MAXCHR];            // Basic character stats
EXTERN Sint16            chrlifemax[MAXCHR];         //   All 8.8 fixed point
EXTERN Uint16          chrlifeheal[MAXCHR];        //
EXTERN Uint8           chrmanacolor[MAXCHR];       // Bar color
EXTERN Uint8           chrammomax[MAXCHR];         // Ammo stuff
EXTERN Uint8           chrammo[MAXCHR];            //
EXTERN Uint8           chrgender[MAXCHR];          // Gender
EXTERN Sint16            chrmana[MAXCHR];            // Mana stuff
EXTERN Sint16            chrmanamax[MAXCHR];         //
EXTERN Sint16            chrmanaflow[MAXCHR];        //
EXTERN Sint16            chrmanareturn[MAXCHR];      //
EXTERN Sint16            chrstrength[MAXCHR];        // Strength
EXTERN Sint16            chrwisdom[MAXCHR];          // Wisdom
EXTERN Sint16            chrintelligence[MAXCHR];    // Intelligence
EXTERN Sint16            chrdexterity[MAXCHR];       // Dexterity
EXTERN Uint8           chraitype[MAXCHR];          // The AI script to run
EXTERN bool_t                  chricon[MAXCHR];            // Show the icon?
EXTERN bool_t                  chrcangrabmoney[MAXCHR];    // Picks up coins?
EXTERN bool_t                  chrisplayer[MAXCHR];        // btrue = player
EXTERN bool_t                  chrislocalplayer[MAXCHR];   // btrue = local player
EXTERN Uint16          chraitarget[MAXCHR];        // Who the AI is after
EXTERN Uint16          chraiowner[MAXCHR];         // The character's owner
EXTERN Uint16          chraichild[MAXCHR];         // The character's child
EXTERN int                     chraistate[MAXCHR];         // Short term memory for AI
EXTERN int                     chraicontent[MAXCHR];       // More short term memory
EXTERN Uint16          chraitime[MAXCHR];          // AI Timer
EXTERN Uint8           chraigoto[MAXCHR];          // Which waypoint
EXTERN Uint8           chraigotoadd[MAXCHR];       // Where to stick next
EXTERN float                   chraigotox[MAXCHR][MAXWAY]; // Waypoint
EXTERN float                   chraigotoy[MAXCHR][MAXWAY]; // Waypoint
EXTERN int                     chraix[MAXCHR][MAXSTOR];    // Temporary values...  SetXY
EXTERN int                     chraiy[MAXCHR][MAXSTOR];    //
EXTERN Uint8           chrstickybutt[MAXCHR];      // Rests on floor
EXTERN Uint8           chrenviro[MAXCHR];          // Environment map?
EXTERN float                   chroldx[MAXCHR];            // Character's last position
EXTERN float                   chroldy[MAXCHR];            //
EXTERN float                   chroldz[MAXCHR];            //
EXTERN bool_t          chrinwater[MAXCHR];         //
EXTERN Uint16          chroldturn[MAXCHR];         //
EXTERN Uint32            chralert[MAXCHR];           // Alerts for AI script
EXTERN float           chrflyheight[MAXCHR];       // Height to stabilize at
EXTERN Uint8           chrteam[MAXCHR];            // Character's team
EXTERN Uint8           chrbaseteam[MAXCHR];        // Character's starting team
EXTERN bool_t          chrstaton[MAXCHR];          // Display stats?
EXTERN float                   chrxstt[MAXCHR];            // Starting position
EXTERN float                   chrystt[MAXCHR];            //
EXTERN float                   chrzstt[MAXCHR];            //
EXTERN float                   chrxpos[MAXCHR];            // Character's position
EXTERN float                   chrypos[MAXCHR];            //
EXTERN float                   chrzpos[MAXCHR];            //
EXTERN float                   chrxtrgvel[MAXCHR];            // Character's target velocity
EXTERN float                   chrytrgvel[MAXCHR];            //
EXTERN float                   chrztrgvel[MAXCHR];            //
EXTERN float                   chrxvel[MAXCHR];            // Character's velocity
EXTERN float                   chryvel[MAXCHR];            //
EXTERN float                   chrzvel[MAXCHR];            //
EXTERN float                   chrlatchx[MAXCHR];          // Character latches
EXTERN float                   chrlatchy[MAXCHR];          //
EXTERN Uint8           chrlatchbutton[MAXCHR];     // Button latches
EXTERN float           chrreloadtime[MAXCHR];      // Time before another shot
EXTERN float                   chrmaxaccel[MAXCHR];        // Maximum acceleration
EXTERN float                   chrscale[MAXCHR];           // Character's size (useful)
EXTERN float                   chrfat[MAXCHR];             // Character's size (legible)
EXTERN float                   chrsizegoto[MAXCHR];        // Character's size goto ( legible )
EXTERN float           chrsizegototime[MAXCHR];    // Time left in siez change
EXTERN float                   chrdampen[MAXCHR];          // Bounciness
EXTERN float                   chrlevel[MAXCHR];           // Height of tile
EXTERN float                   chrjump[MAXCHR];            // Jump power
EXTERN float           chrjumptime[MAXCHR];        // Delay until next jump
EXTERN float           chrjumpnumber[MAXCHR];      // Number of jumps remaining
EXTERN Uint8           chrjumpnumberreset[MAXCHR]; // Number of jumps total, 255=Flying
EXTERN bool_t          chrjumpready[MAXCHR];       // For standing on a platform character
EXTERN Uint32          chronwhichfan[MAXCHR];      // Where the char is
EXTERN bool_t          chrindolist[MAXCHR];        // Has it been added yet?
EXTERN Uint16          chruoffset[MAXCHR];         // For moving textures
EXTERN Uint16          chrvoffset[MAXCHR];         //
EXTERN Uint16          chruoffvel[MAXCHR];         // Moving texture speed
EXTERN Uint16          chrvoffvel[MAXCHR];         //
EXTERN Uint16          chrturnleftright[MAXCHR];   // Character's rotation 0 to 65535
EXTERN Uint16          chrturnmaplr[MAXCHR];       //
EXTERN Uint16          chrturnmapud[MAXCHR];       //
EXTERN Uint16          chrtexture[MAXCHR];         // Character's skin
EXTERN Uint8           chrmodel[MAXCHR];           // Character's model
EXTERN Uint8           chrbasemodel[MAXCHR];       // The true form
EXTERN bool_t          chractionready[MAXCHR];     // Ready to play a new one
EXTERN Uint8           chraction[MAXCHR];          // Character's action
EXTERN bool_t          chrkeepaction[MAXCHR];      // Keep the action playing
EXTERN bool_t          chrloopaction[MAXCHR];      // Loop it too
EXTERN Uint8           chrnextaction[MAXCHR];      // Character's action to play next
EXTERN Uint16          chrframe[MAXCHR];           // Character's frame
EXTERN Uint16          chrlastframe[MAXCHR];       // Character's last frame
EXTERN float           chrflip[MAXCHR];
EXTERN Uint8           chrlip[MAXCHR];             // Character's frame in betweening
EXTERN Uint8           chrvrta[MAXCHR][MAXVERTICES];// Lighting hack ( Ooze )
EXTERN Uint16          chrholdingwhich[MAXCHR][2]; // !=MAXCHR if character is holding something
EXTERN Uint16          chrattachedto[MAXCHR];      // !=MAXCHR if character is a held weapon
EXTERN Uint16          chrweapongrip[MAXCHR][4];   // Vertices which describe the weapon grip
EXTERN Uint8           chralpha[MAXCHR];           // 255 = Solid, 0 = Invisible
EXTERN Uint8           chrlight[MAXCHR];           // 1 = Light, 0 = Normal
EXTERN Uint8           chrflashand[MAXCHR];        // 1,3,7,15,31 = Flash, 255 = Don't
EXTERN Uint8           chrlightambi[MAXCHR];      // 0-255, terrain light
EXTERN Uint8           chrlightspek[MAXCHR];      // 0-255, terrain light
EXTERN Uint16          chrlightturnleftright[MAXCHR];// Character's light rotation 0 to 65535
EXTERN Uint8           chrsheen[MAXCHR];           // 0-15, how shiny it is
EXTERN Uint8           chrtransferblend[MAXCHR];   // Give transparency to weapons?
EXTERN bool_t          chrisitem[MAXCHR];          // Is it grabbable?
EXTERN Uint8           chrismount[MAXCHR];         // Can you ride it?
EXTERN Uint8           chrredshift[MAXCHR];        // Color channel shifting
EXTERN Uint8           chrgrnshift[MAXCHR];        //
EXTERN Uint8           chrblushift[MAXCHR];        //
EXTERN Uint8           chrshadowsize[MAXCHR];      // Size of shadow
EXTERN Uint8           chrbumpsize[MAXCHR];        // Size of bumpers
EXTERN Uint8           chrbumpsizebig[MAXCHR];     // For octagonal bumpers
EXTERN Uint8           chrbumpheight[MAXCHR];      // Distance from head to toe
EXTERN Uint8           chrshadowsizesave[MAXCHR];  // Without size modifiers
EXTERN Uint8           chrbumpsizesave[MAXCHR];    //
EXTERN Uint8           chrbumpsizebigsave[MAXCHR]; //
EXTERN Uint8           chrbumpheightsave[MAXCHR];  //
EXTERN Uint16          chrbumpnext[MAXCHR];        // Next character on fanblock
EXTERN Uint16          chrbumplast[MAXCHR];        // Last character it was bumped by
EXTERN float           chrbumpdampen[MAXCHR];      // Character bump mass
EXTERN Uint16          chrattacklast[MAXCHR];      // Last character it was attacked by
EXTERN Uint16          chrhitlast[MAXCHR];         // Last character it hit
EXTERN Uint16          chrdirectionlast[MAXCHR];   // Direction of last attack/healing
EXTERN Uint8           chrdamagetypelast[MAXCHR];  // Last damage type
EXTERN bool_t          chrplatform[MAXCHR];        // Can it be stood on
EXTERN Uint8           chrturnmode[MAXCHR];        // Turning mode
EXTERN Uint8           chrsneakspd[MAXCHR];        // Sneaking if above this speed
EXTERN Uint8           chrwalkspd[MAXCHR];         // Walking if above this speed
EXTERN Uint8           chrrunspd[MAXCHR];          // Running if above this speed
EXTERN Uint8           chrdamagetargettype[MAXCHR];// Type of damage for AI DamageTarget
EXTERN Uint8           chrreaffirmdamagetype[MAXCHR]; // For relighting torches
EXTERN Uint8           chrdamagemodifier[MAXCHR][MAXDAMAGETYPE];  // Resistances and inversion
EXTERN float           chrdamagetime[MAXCHR];      // Invincibility timer
EXTERN Uint8           chrdefense[MAXCHR];         // Base defense rating
EXTERN Uint16          chrweight[MAXCHR];          // Weight ( for pressure plates )
EXTERN Uint8           chrpassage[MAXCHR];         // The passage associated with this character
EXTERN Uint32          chrorder[MAXCHR];           // The last order given the character
EXTERN Uint8           chrcounter[MAXCHR];         // The rank of the character on the order chain
EXTERN Uint16          chronwhichplatform[MAXCHR]; // What are we standing on?
EXTERN Uint16          chrholdingweight[MAXCHR];   // For weighted buttons
EXTERN signed   int            chrmoney[MAXCHR];           // Money
EXTERN signed   short          chrlifereturn[MAXCHR];      // Regeneration/poison
EXTERN signed   short          chrmanacost[MAXCHR];        // Mana cost to use
EXTERN Uint8           chrstoppedby[MAXCHR];       // Collision mask
EXTERN int                     chrexperience[MAXCHR];      // Experience
EXTERN int                     chrexperiencelevel[MAXCHR]; // Experience Level
EXTERN Sint16            chrgrogtime[MAXCHR];        // Grog timer
EXTERN Sint16            chrdazetime[MAXCHR];        // Daze timer
EXTERN bool_t          chrnameknown[MAXCHR];       // Is the name known?
EXTERN bool_t          chrammoknown[MAXCHR];       // Is the ammo known?
EXTERN bool_t          chrhitready[MAXCHR];        // Was it just dropped?
EXTERN float           chrboretime[MAXCHR];        // Boredom timer
EXTERN float           chrcarefultime[MAXCHR];     // "You hurt me!" timer
EXTERN Uint8           chrcanbecrushed[MAXCHR];    // Crush in a door?
EXTERN Uint8           chrinwhichhand[MAXCHR];     // GRIPLEFT or GRIPRIGHT
EXTERN bool_t          chrisequipped[MAXCHR];      // For boots and rings and stuff
EXTERN Uint8           chrfirstenchant[MAXCHR];    // Linked list for enchants
EXTERN Uint8           chrundoenchant[MAXCHR];     // Last enchantment spawned
EXTERN Uint8           chrmissiletreatment[MAXCHR];// For deflection, etc.
EXTERN Uint8           chrmissilecost[MAXCHR];     // Mana cost for each one
EXTERN Uint16          chrmissilehandler[MAXCHR];  // Who pays the bill for each one...
EXTERN Uint16          chrdamageboost[MAXCHR];     // Add to swipe damage
EXTERN bool_t          chroverlay[MAXCHR];         // Is this an overlay?  Track aitarget...

// [BEGIN] Character states that are like skill expansions
EXTERN bool_t     chrinvictus[MAXCHR];          // Totally invincible?
EXTERN bool_t     chrwaterwalk[MAXCHR];         // Always above watersurfacelevel?
EXTERN bool_t     chriskursed[MAXCHR];          // Can't be dropped?  Could this also mean damage debuff? Spell fizzle rate? etc.
EXTERN bool_t     chrcanseeinvisible[MAXCHR];   //
EXTERN bool_t     chrcanchannel[MAXCHR];        //
// [END] Character states that are like skill expansions

// [BEGIN] Skill Expansions
EXTERN bool_t     chrcanseekurse[MAXCHR];             // Can it see kurses?
EXTERN bool_t     chrcanusearcane[MAXCHR];            // Can use [WMAG] spells?
EXTERN bool_t     chrcanjoust[MAXCHR];                // Can it use a lance to joust?
EXTERN bool_t     chrcanusetech[MAXCHR];              // Can it use [TECH]items?
EXTERN bool_t     chrcanusedivine[MAXCHR];            // Can it use [HMAG] runes?
EXTERN bool_t     chrcandisarm[MAXCHR];               // Disarm and find traps [DISA]
EXTERN bool_t     chrcanbackstab[MAXCHR];             // Backstab and murder [STAB]
EXTERN bool_t     chrcanuseadvancedweapons[MAXCHR];   // Advanced weapons usage [AWEP]
EXTERN bool_t     chrcanusepoison[MAXCHR];            // Use poison without err [POIS]
EXTERN bool_t     chrcanread[MAXCHR];				 // Can read books and scrolls
// [END]  Skill Expansions

#define SEEKURSEAND         31                      // Blacking flash
#define SEEINVISIBLE        128                     // Cutoff for invisible characters
#define INVISIBLE           20                      // The character can't be detected
EXTERN bool_t                    localseeinvisible;
EXTERN bool_t                    localseekurse;


//------------------------------------
//Enchantment variables
//------------------------------------

typedef enum eve_set_e
{
  SETDAMAGETYPE           = 0,
  SETNUMBEROFJUMPS,      
  SETLIFEBARCOLOR,       
  SETMANABARCOLOR,       
  SETSLASHMODIFIER,       //Damage modifiers
  SETCRUSHMODIFIER,      
  SETPOKEMODIFIER,       
  SETHOLYMODIFIER,       
  SETEVILMODIFIER,       
  SETFIREMODIFIER,       
  SETICEMODIFIER,        
  SETZAPMODIFIER,        
  SETFLASHINGAND,        
  SETLIGHTBLEND,         
  SETALPHABLEND,         
  SETSHEEN,                //Shinyness
  SETFLYTOHEIGHT,        
  SETWALKONWATER,        
  SETCANSEEINVISIBLE,    
  SETMISSILETREATMENT,   
  SETCOSTFOREACHMISSILE, 
  SETMORPH,                //Morph character?
  SETCHANNEL,               //Can channel life as mana?
  EVE_SET_COUNT
} EVE_SET;

typedef enum eve_add_e
{
  ADDJUMPPOWER = 0,
  ADDBUMPDAMPEN,    
  ADDBOUNCINESS,    
  ADDDAMAGE,        
  ADDSIZE,          
  ADDACCEL,         
  ADDRED,             //Red shift
  ADDGRN,             //Green shift
  ADDBLU,             //Blue shift
  ADDDEFENSE,         //Defence adjustments
  ADDMANA,          
  ADDLIFE,          
  ADDSTRENGTH,      
  ADDWISDOM,        
  ADDINTELLIGENCE,  
  ADDDEXTERITY,
  EVE_ADD_COUNT      // Number of adds
} EVE_ADD;

EXTERN Uint16    numfreeenchant;             // For allocating new ones
EXTERN Uint16    freeenchant[MAXENCHANT];    //

EXTERN bool_t                    evevalid[MAXEVE];                       // Enchant.txt loaded?
EXTERN bool_t                    eveoverride[MAXEVE];                    // Override other enchants?
EXTERN bool_t                    everemoveoverridden[MAXEVE];            // Remove other enchants?
EXTERN bool_t                    evesetyesno[MAXEVE][EVE_SET_COUNT];    // Set this value?
EXTERN Uint8             evesetvalue[MAXEVE][EVE_SET_COUNT];    // Value to use
EXTERN Sint8               eveaddvalue[MAXEVE][EVE_ADD_COUNT];    // The values to add
EXTERN bool_t                    everetarget[MAXEVE];                    // Pick a weapon?
EXTERN bool_t                    evekillonend[MAXEVE];                   // Kill the target on end?
EXTERN bool_t                    evepoofonend[MAXEVE];                   // Spawn a poof on end?
EXTERN bool_t                    eveendifcantpay[MAXEVE];                // End on out of mana
EXTERN bool_t                    evestayifnoowner[MAXEVE];               // Stay if owner has died?
EXTERN Sint16            evetime[MAXEVE];                        // Time in seconds
EXTERN Sint8             eveendmessage[MAXEVE];                  // Message for end -1 for none
EXTERN Sint16            eveownermana[MAXEVE];                   // Boost values
EXTERN Sint16            eveownerlife[MAXEVE];                   //
EXTERN Sint16            evetargetmana[MAXEVE];                  //
EXTERN Sint16            evetargetlife[MAXEVE];                  //
EXTERN Uint8           evedontdamagetype[MAXEVE];              // Don't work if ...
EXTERN Uint8           eveonlydamagetype[MAXEVE];              // Only work if ...
EXTERN IDSZ            everemovedbyidsz[MAXEVE];               // By particle or [NONE]
EXTERN Uint16          evecontspawntime[MAXEVE];               // Spawn timer
EXTERN Uint8           evecontspawnamount[MAXEVE];             // Spawn amount
EXTERN Uint16          evecontspawnfacingadd[MAXEVE];          // Spawn in circle
EXTERN Uint16          evecontspawnpip[MAXEVE];                // Spawn type ( local )
EXTERN Mix_Chunk  *    evewaveindex[MAXEVE];                   // Sound on end (-1 for none)
EXTERN Uint16          evefrequency[MAXEVE];                   // Sound frequency
EXTERN Uint8           eveoverlay[MAXEVE];                     // Spawn an overlay?

EXTERN Uint8           encon[MAXENCHANT];                      // Enchantment on
EXTERN Uint8           enceve[MAXENCHANT];                     // The type
EXTERN Uint16          enctarget[MAXENCHANT];                  // Who it enchants
EXTERN Uint16          encnextenchant[MAXENCHANT];             // Next in the list
EXTERN Uint16          encowner[MAXENCHANT];                   // Who cast the enchant
EXTERN Uint16          encspawner[MAXENCHANT];                 // The spellbook character
EXTERN Uint16          encoverlay[MAXENCHANT];                 // The overlay character
EXTERN Sint16            encownermana[MAXENCHANT];               // Boost values
EXTERN Sint16            encownerlife[MAXENCHANT];               //
EXTERN Sint16            enctargetmana[MAXENCHANT];              //
EXTERN Sint16            enctargetlife[MAXENCHANT];              //
EXTERN bool_t                  encsetyesno[MAXENCHANT][EVE_SET_COUNT];// Was it set?
EXTERN Uint8           encsetsave[MAXENCHANT][EVE_SET_COUNT]; // The value to restore
EXTERN Sint16            encaddsave[MAXENCHANT][EVE_ADD_COUNT]; // The value to take away
EXTERN Sint16            enctime[MAXENCHANT];                    // Time before end
EXTERN float            encspawntime[MAXENCHANT];               // Time before spawn

#define MISNORMAL               0         //Treat missiles normally
#define MISDEFLECT              1         //Deflect incoming missiles
#define MISREFLECT              2         //Reflect them back!

#define LEAVEALL                0
#define LEAVEFIRST              1
#define LEAVENONE               2

//------------------------------------
//Particle variables
//------------------------------------
#define SPAWNNOCHARACTER        255                 // For particles that spawn characters...

EXTERN float                   textureoffset[256];         // For moving textures
EXTERN Uint16          dolist[MAXCHR];             // List of which characters to draw
EXTERN Uint16          numdolist;                  // How many in the list

EXTERN int                     numfreeprt EQ(0);                           // For allocation
EXTERN Uint16          freeprtlist[MAXPRT];                        //
EXTERN bool_t          prton[MAXPRT];                              // Does it exist?
EXTERN Uint16          prtpip[MAXPRT];                             // The part template
EXTERN Uint16          prtmodel[MAXPRT];                           // Pip spawn model
EXTERN Uint16          prtattachedtocharacter[MAXPRT];             // For torch flame
EXTERN Uint16          prtgrip[MAXPRT];                            // The vertex it's on
EXTERN Uint8           prttype[MAXPRT];                            // Transparency mode, 0-2
EXTERN Uint16          prtfacing[MAXPRT];                          // Direction of the part
EXTERN Uint8           prtteam[MAXPRT];                            // Team
EXTERN float           prtxpos[MAXPRT];                            // Position
EXTERN float           prtypos[MAXPRT];                            //
EXTERN float           prtzpos[MAXPRT];                            //
EXTERN float           prtxvel[MAXPRT];                            // Velocity
EXTERN float           prtyvel[MAXPRT];                            //
EXTERN float           prtzvel[MAXPRT];                            //
EXTERN float           prtlevel[MAXPRT];                           // Height of tile
EXTERN Uint8           prtspawncharacterstate[MAXPRT];             //
EXTERN Uint16          prtrotate[MAXPRT];                          // Rotation direction
EXTERN Sint16          prtrotateadd[MAXPRT];                       // Rotation rate
EXTERN Uint32          prtonwhichfan[MAXPRT];                      // Where the part is
EXTERN Uint16          prtsize[MAXPRT];                            // Size of particle>>8
EXTERN Sint16          prtsizeadd[MAXPRT];                         // Change in size
EXTERN Uint8           prtinview[MAXPRT];                          // Render this one?
EXTERN Uint32          prtimage[MAXPRT];                           // Which image ( >> 8 )
EXTERN Uint32          prtimageadd[MAXPRT];                        // Animation rate
EXTERN Uint32          prtimagemax[MAXPRT];                        // End of image loop
EXTERN Uint32          prtimagestt[MAXPRT];                        // Start of image loop
EXTERN Uint8           prtlight[MAXPRT];                           // Light level
EXTERN float           prttime[MAXPRT];                            // Duration of particle
EXTERN Uint16          prtgopoof[MAXPRT];                          // Are we gone?
EXTERN float           prtspawntime[MAXPRT];                       // Time until spawn
EXTERN Uint8           prtbumpsize[MAXPRT];                        // Size of bumpers
EXTERN Uint8           prtbumpsizebig[MAXPRT];                     //
EXTERN Uint8           prtbumpheight[MAXPRT];                      // Bounding box height
EXTERN Uint16          prtbumpnext[MAXPRT];                        // Next particle on fanblock
EXTERN Uint16          prtdamagebase[MAXPRT];                      // For strength
EXTERN Uint16          prtdamagerand[MAXPRT];                      // For fixes...
EXTERN Uint8           prtdamagetype[MAXPRT];                      // Damage type
EXTERN Uint16          prtchr[MAXPRT];                             // The character that is attacking
EXTERN float           prtdynalightfalloff[MAXPRT];                // Dyna light...
EXTERN float           prtdynalightlevel[MAXPRT];                  //
EXTERN Uint8           prtdynalighton[MAXPRT];                     // Dynamic light?
EXTERN Uint16          prttarget[MAXPRT];                          // Who it's chasing
EXTERN Uint16          particletexture;                            // All in one bitmap
EXTERN Uint16          prttexw;
EXTERN Uint16          prttexh;
EXTERN float                   prttexwscale EQ(1.0f);
EXTERN float                   prttexhscale EQ(1.0f);
//EXTERN float                   particleimageu[MAXPARTICLEIMAGE][2];        // Texture coordinates
//EXTERN float                   particleimagev[MAXPARTICLEIMAGE][2];        //

#define CALCULATE_PRT_U0(CNT)  (((.05f+(CNT&15))/16.0f)*prttexwscale)
#define CALCULATE_PRT_U1(CNT)  (((.95f+(CNT&15))/16.0f)*prttexwscale)
#define CALCULATE_PRT_V0(CNT)  (((.05f+(CNT/16))/16.0f) * ((float)prttexw/(float)prttexh)*prttexhscale)
#define CALCULATE_PRT_V1(CNT)  (((.95f+(CNT/16))/16.0f) * ((float)prttexw/(float)prttexh)*prttexhscale)

//------------------------------------
//Module variables
//------------------------------------
#define RANKSIZE 8
#define SUMMARYLINES 8
#define SUMMARYSIZE  80
EXTERN int             globalnummodule;                            // Number of modules
EXTERN char            modrank[MAXMODULE][RANKSIZE];               // Number of stars
EXTERN char            modlongname[MAXMODULE][MAXCAPNAMESIZE];     // Module names
EXTERN char            modsummaryval;
EXTERN char            modloadname[MAXMODULE][MAXCAPNAMESIZE];     // Module load names
EXTERN Uint8           modimportamount[MAXMODULE];                 // # of import characters
EXTERN bool_t          modallowexport[MAXMODULE];                  // Export characters?
EXTERN Uint8           modminplayers[MAXMODULE];                   // Number of players
EXTERN Uint8           modmaxplayers[MAXMODULE];                   //
EXTERN bool_t          modmonstersonly[MAXMODULE];                 // Only allow monsters
EXTERN bool_t          modrespawnvalid[MAXMODULE];                 // Allow respawn
EXTERN int             numlines;                                   // Lines in summary
EXTERN char            modsummary[SUMMARYLINES][SUMMARYSIZE];      // Quest description


//------------------------------------
//Model stuff
//------------------------------------
// TEMPORARY: Needs to be moved out of egoboo.h eventually
extern Md2Model *md2_models[MAXMODEL];          // Md2 models

EXTERN int                     globalnumicon;                              // Number of icons
EXTERN Uint16          madloadframe;                               // Where to load next
EXTERN bool_t          madused[MAXMODEL];                          // Model slot
EXTERN char                    madname[MAXMODEL][128];                     // Model name
EXTERN Uint16          madskintoicon[MAXTEXTURE];                  // Skin to icon
EXTERN Uint16          madskins[MAXMODEL];                         // Number of skins
EXTERN Uint16          madskinstart[MAXMODEL];                     // Starting skin of model
EXTERN Uint16          madframes[MAXMODEL];                        // Number of frames
EXTERN Uint16          madframestart[MAXMODEL];                    // Starting frame of model
EXTERN Uint16          madmsgstart[MAXMODEL];                      // The first message
EXTERN Uint16          madvertices[MAXMODEL];                      // Number of vertices
EXTERN Uint16          madtransvertices[MAXMODEL];                 // Number to transform
EXTERN Uint16          madcommands[MAXMODEL];                      // Number of commands
EXTERN float                   madscale[MAXMODEL];                         // Multiply by value
EXTERN GLenum       madcommandtype[MAXMODEL][MAXCOMMAND];       // Fan or strip
EXTERN Uint8           madcommandsize[MAXMODEL][MAXCOMMAND];       // Entries used by command
EXTERN Uint16          madcommandvrt[MAXMODEL][MAXCOMMANDENTRIES]; // Which vertex
EXTERN float                   madcommandu[MAXMODEL][MAXCOMMANDENTRIES];   // Texture position
EXTERN float                   madcommandv[MAXMODEL][MAXCOMMANDENTRIES];   //
EXTERN Sint16            madvrtx[MAXFRAME][MAXVERTICES];             // Vertex position
EXTERN Sint16            madvrty[MAXFRAME][MAXVERTICES];             //
EXTERN Sint16            madvrtz[MAXFRAME][MAXVERTICES];             //
EXTERN Uint8           madvrta[MAXFRAME][MAXVERTICES];             // Light index of vertex
EXTERN Uint8           madframelip[MAXFRAME];                      // 0-15, How far into action is each frame
EXTERN Uint16          madframefx[MAXFRAME];                       // Invincibility, Spawning
EXTERN Uint16          madframeliptowalkframe[MAXMODEL][4][16];    // For walk animations
EXTERN Uint16          madai[MAXMODEL];                            // AI for each model
EXTERN bool_t          madactionvalid[MAXMODEL][MAXACTION];        // bfalse if not valid
EXTERN Uint16          madactionstart[MAXMODEL][MAXACTION];        // First frame of anim
EXTERN Uint16          madactionend[MAXMODEL][MAXACTION];          // One past last frame
EXTERN Uint16          madprtpip[MAXMODEL][PRTPIP_PEROBJECT_COUNT];    // Local particles


// Character profiles
#define MAXSKIN 4
EXTERN int                   importobject;
EXTERN short                 capimportslot[MAXMODEL];
EXTERN char                  capclassname[MAXMODEL][MAXCAPNAMESIZE];     // Class name
EXTERN Sint8           capskinoverride[MAXMODEL];                  // -1 or 0-3.. For import
EXTERN Uint8         capleveloverride[MAXMODEL];                 // 0 for normal
EXTERN int                   capstateoverride[MAXMODEL];                 // 0 for normal
EXTERN int                   capcontentoverride[MAXMODEL];               // 0 for normal
EXTERN Uint8         capskindressy[MAXMODEL];                    // Dressy
EXTERN float                 capstrengthdampen[MAXMODEL];                // Strength damage factor
EXTERN Uint8         capstoppedby[MAXMODEL];                     // Collision Mask
EXTERN bool_t        capuniformlit[MAXMODEL];                    // Bad lighting?
EXTERN Uint8         caplifecolor[MAXMODEL];                     // Bar colors
EXTERN Uint8         capmanacolor[MAXMODEL];                     //
EXTERN Uint8         capammomax[MAXMODEL];                       // Ammo stuff
EXTERN Uint8         capammo[MAXMODEL];                          //
EXTERN Uint8         capgender[MAXMODEL];                        // Gender
EXTERN Uint16        caplifebase[MAXMODEL];                      // Life
EXTERN Uint16        capliferand[MAXMODEL];                      //
EXTERN Uint16        caplifeperlevelbase[MAXMODEL];              //
EXTERN Uint16        caplifeperlevelrand[MAXMODEL];              //
EXTERN Sint16          caplifereturn[MAXMODEL];                    //
EXTERN Sint16          capmoney[MAXMODEL];                         // Money
EXTERN Uint16        caplifeheal[MAXMODEL];                      //
EXTERN Uint16        capmanabase[MAXMODEL];                      // Mana
EXTERN Uint16        capmanarand[MAXMODEL];                      //
EXTERN Sint16          capmanacost[MAXMODEL];                      //
EXTERN Uint16        capmanaperlevelbase[MAXMODEL];              //
EXTERN Uint16        capmanaperlevelrand[MAXMODEL];              //
EXTERN Uint16        capmanareturnbase[MAXMODEL];                //
EXTERN Uint16        capmanareturnrand[MAXMODEL];                //
EXTERN Uint16        capmanareturnperlevelbase[MAXMODEL];        //
EXTERN Uint16        capmanareturnperlevelrand[MAXMODEL];        //
EXTERN Uint16        capmanaflowbase[MAXMODEL];                  //
EXTERN Uint16        capmanaflowrand[MAXMODEL];                  //
EXTERN Uint16        capmanaflowperlevelbase[MAXMODEL];          //
EXTERN Uint16        capmanaflowperlevelrand[MAXMODEL];          //
EXTERN Uint16        capstrengthbase[MAXMODEL];                  // Strength
EXTERN Uint16        capstrengthrand[MAXMODEL];                  //
EXTERN Uint16        capstrengthperlevelbase[MAXMODEL];          //
EXTERN Uint16        capstrengthperlevelrand[MAXMODEL];          //
EXTERN Uint16        capwisdombase[MAXMODEL];                    // Wisdom
EXTERN Uint16        capwisdomrand[MAXMODEL];                    //
EXTERN Uint16        capwisdomperlevelbase[MAXMODEL];            //
EXTERN Uint16        capwisdomperlevelrand[MAXMODEL];            //
EXTERN Uint16        capintelligencebase[MAXMODEL];              // Intlligence
EXTERN Uint16        capintelligencerand[MAXMODEL];              //
EXTERN Uint16        capintelligenceperlevelbase[MAXMODEL];      //
EXTERN Uint16        capintelligenceperlevelrand[MAXMODEL];      //
EXTERN Uint16        capdexteritybase[MAXMODEL];                 // Dexterity
EXTERN Uint16        capdexterityrand[MAXMODEL];                 //
EXTERN Uint16        capdexterityperlevelbase[MAXMODEL];         //
EXTERN Uint16        capdexterityperlevelrand[MAXMODEL];         //
EXTERN float                 capsize[MAXMODEL];                          // Scale of model
EXTERN float                 capsizeperlevel[MAXMODEL];                  // Scale increases
EXTERN float                 capdampen[MAXMODEL];                        // Bounciness
EXTERN Uint8         capshadowsize[MAXMODEL];                    // Shadow size
EXTERN Uint8         capbumpsize[MAXMODEL];                      // Bounding octagon
EXTERN Uint8         capbumpsizebig[MAXMODEL];                   // For octagonal bumpers
EXTERN Uint8         capbumpheight[MAXMODEL];                    //
EXTERN float                 capbumpdampen[MAXMODEL];                    // Mass
EXTERN Uint8         capweight[MAXMODEL];                        // Weight
EXTERN float                 capjump[MAXMODEL];                          // Jump power
EXTERN Uint8         capjumpnumber[MAXMODEL];                    // Number of jumps ( Ninja )
EXTERN Uint8         capsneakspd[MAXMODEL];                      // Sneak threshold
EXTERN Uint8         capwalkspd[MAXMODEL];                       // Walk threshold
EXTERN Uint8         caprunspd[MAXMODEL];                        // Run threshold
EXTERN Uint8         capflyheight[MAXMODEL];                     // Fly height
EXTERN Uint8         capflashand[MAXMODEL];                      // Flashing rate
EXTERN Uint8         capalpha[MAXMODEL];                         // Transparency
EXTERN Uint8         caplight[MAXMODEL];                         // Light blending
EXTERN bool_t        captransferblend[MAXMODEL];                 // Transfer blending to rider/weapons
EXTERN Uint8         capsheen[MAXMODEL];                         // How shiny it is ( 0-15 )
EXTERN bool_t        capenviro[MAXMODEL];                        // Phong map this baby?
EXTERN Uint16        capuoffvel[MAXMODEL];                       // Texture movement rates
EXTERN Uint16        capvoffvel[MAXMODEL];                       //
EXTERN bool_t        capstickybutt[MAXMODEL];                    // Stick to the ground?
EXTERN Uint16        capiframefacing[MAXMODEL];                  // Invincibility frame
EXTERN Uint16        capiframeangle[MAXMODEL];                   //
EXTERN Uint16        capnframefacing[MAXMODEL];                  // Normal frame
EXTERN Uint16        capnframeangle[MAXMODEL];                   //
EXTERN Uint8         capresistbumpspawn[MAXMODEL];               // Don't catch fire
EXTERN int                   capexperienceforlevel[MAXMODEL][MAXLEVEL];  // Experience needed for next level
EXTERN float                 capexperiencepower[MAXMODEL];
EXTERN float                 capexperiencecoeff[MAXMODEL];
EXTERN int                   capexperiencebase[MAXMODEL];                // Starting experience
EXTERN int                   capexperiencerand[MAXMODEL];                //
EXTERN int                   capexperienceworth[MAXMODEL];               // Amount given to killer/user
EXTERN float                 capexperienceexchange[MAXMODEL];            // Adds to worth
EXTERN float                 capexperiencerate[MAXMODEL][MAXEXPERIENCETYPE];
EXTERN IDSZ                  capidsz[MAXMODEL][MAXIDSZ];                 // ID strings
EXTERN bool_t                capisitem[MAXMODEL];                        // Is it an item?
EXTERN bool_t                capismount[MAXMODEL];                       // Can you ride it?
EXTERN bool_t                capisstackable[MAXMODEL];                   // Is it arrowlike?
EXTERN bool_t                capnameknown[MAXMODEL];                     // Is the class name known?
EXTERN bool_t                capusageknown[MAXMODEL];                    // Is its usage known
EXTERN bool_t                capcancarrytonextmodule[MAXMODEL];          // Take it with you?
EXTERN bool_t                capneedskillidtouse[MAXMODEL];              // Check IDSZ first?
EXTERN bool_t                capplatform[MAXMODEL];                      // Can be stood on?
EXTERN bool_t                capcanuseplatforms[MAXMODEL];               // Can use platforms?
EXTERN bool_t                capcangrabmoney[MAXMODEL];                  // Collect money?
EXTERN bool_t                capcanopenstuff[MAXMODEL];                  // Open chests/doors?
EXTERN bool_t                capicon[MAXMODEL];                          // Draw icon
EXTERN bool_t                capforceshadow[MAXMODEL];                   // Draw a shadow?
EXTERN bool_t                capripple[MAXMODEL];                        // Spawn ripples?
EXTERN Uint8         capdamagetargettype[MAXMODEL];              // For AI DamageTarget
EXTERN Uint8         capweaponaction[MAXMODEL];                  // Animation needed to swing
EXTERN bool_t        capgripvalid[MAXMODEL][2];                  // Left/Right hands valid
EXTERN bool_t        capattackattached[MAXMODEL];                //
EXTERN Sint8           capattackprttype[MAXMODEL];                 //
EXTERN Uint8         capattachedprtamount[MAXMODEL];             // Sticky particles
EXTERN Uint8         capattachedprtreaffirmdamagetype[MAXMODEL]; // Relight that torch...
EXTERN Uint8         capattachedprttype[MAXMODEL];               //
EXTERN Uint8         capgopoofprtamount[MAXMODEL];               // Poof effect
EXTERN Sint16          capgopoofprtfacingadd[MAXMODEL];            //
EXTERN Uint8         capgopoofprttype[MAXMODEL];                 //
EXTERN Uint8         capbludvalid[MAXMODEL];                    // Blud ( yuck )
EXTERN Uint8         capbludprttype[MAXMODEL];                  //
EXTERN Sint8         capwavefootfall[MAXMODEL];                  // Footfall sound, -1
EXTERN Sint8         capwavejump[MAXMODEL];                      // Jump sound, -1
EXTERN Uint8         capridercanattack[MAXMODEL];                // Rider attack?
EXTERN bool_t        capcanbedazed[MAXMODEL];                    // Can it be dazed?
EXTERN bool_t        capcanbegrogged[MAXMODEL];                  // Can it be grogged?
EXTERN Uint8         capkursechance[MAXMODEL];                   // Chance of being kursed
EXTERN Uint8         capistoobig[MAXMODEL];                      // Can't be put in pack
EXTERN bool_t        capreflect[MAXMODEL];                       // Draw the reflection
EXTERN Uint8         capalwaysdraw[MAXMODEL];                    // Always render
EXTERN Uint8         capisranged[MAXMODEL];                      // Flag for ranged weapon
EXTERN Sint8         caphidestate[MAXCHR];                       // Don't draw when...
EXTERN bool_t        capisequipment[MAXCHR];                     // Behave in silly ways

EXTERN Uint8         capdefense[MAXMODEL][MAXSKIN];                    // Defense for each skin
EXTERN char                  capskinname[MAXMODEL][MAXSKIN][MAXCAPNAMESIZE];   // Skin name
EXTERN Uint16        capskincost[MAXMODEL][MAXSKIN];                   // Store prices
EXTERN Uint8         capdamagemodifier[MAXMODEL][MAXDAMAGETYPE][MAXSKIN];
EXTERN float                 capmaxaccel[MAXMODEL][MAXSKIN];                   // Acceleration for each skin

// [BEGIN] Character template parameters that are like Skill Expansions
EXTERN bool_t                capwaterwalk[MAXMODEL];                     // Walk on water?
EXTERN bool_t                capinvictus[MAXMODEL];                      // Is it invincible?
EXTERN bool_t                capcanseeinvisible[MAXMODEL];               // Can it see invisible?
// [END] Character template parameters that are like Skill Expansions


// [BEGIN] Skill Expansions
EXTERN bool_t     capcanseekurse[MAXMODEL];                   // Can it see kurses?
EXTERN bool_t     capcanusearcane[MAXMODEL];      // Can use [WMAG] spells?
EXTERN bool_t     capcanjoust[MAXMODEL];       // Can it use a lance to joust?
EXTERN bool_t     capcanusetech[MAXMODEL];      // Can it use [TECH]items?
EXTERN bool_t     capcanusedivine[MAXMODEL];      // Can it use [HMAG] runes?
EXTERN bool_t     capcandisarm[MAXMODEL];         // Disarm and find traps [DISA]
EXTERN bool_t     capcanbackstab[MAXCHR];         // Backstab and murder [STAB]
EXTERN bool_t     capcanuseadvancedweapons[MAXCHR];   // Advanced weapons usage [AWEP]
EXTERN bool_t     capcanusepoison[MAXCHR];         // Use poison without err [POIS]
EXTERN bool_t     capcanread[MAXCHR];			// Can read books and scrolls [READ]
// [END] Skill Expansions


// Particle template
#define DYNAOFF   0
#define DYNAON    1
#define DYNALOCAL 2
#define DYNAFANS  12
#define MAXFALLOFF 1400

EXTERN int                     numpip  EQ(0);
EXTERN Uint8           pipforce[MAXPRTPIP];                        // Force spawn?
EXTERN Uint8           piptype[MAXPRTPIP];                         // Transparency mode
EXTERN Uint8           pipnumframes[MAXPRTPIP];                    // Number of frames
EXTERN Uint16          pipimagebase[MAXPRTPIP];                    // Starting image
EXTERN Uint32            pipimageadd[MAXPRTPIP];                     // Frame rate
EXTERN Uint32            pipimageaddrand[MAXPRTPIP];                 // Frame rate randomness
EXTERN Uint16          piptime[MAXPRTPIP];                         // Time until end
EXTERN Uint16          piprotatebase[MAXPRTPIP];                   // Rotation
EXTERN Uint16          piprotaterand[MAXPRTPIP];                   // Rotation
EXTERN Sint16            piprotateadd[MAXPRTPIP];                    // Rotation rate
EXTERN Uint16          pipsizebase[MAXPRTPIP];                     // Size
EXTERN Sint16            pipsizeadd[MAXPRTPIP];                      // Size rate
EXTERN float                   pipspdlimit[MAXPRTPIP];                     // Speed limit
EXTERN float                   pipdampen[MAXPRTPIP];                       // Bounciness
EXTERN Sint8             pipbumpmoney[MAXPRTPIP];                    // Value of particle
EXTERN Uint8           pipbumpsize[MAXPRTPIP];                     // Bounding box size
EXTERN Uint8           pipbumpheight[MAXPRTPIP];                   // Bounding box height
EXTERN Uint8           pipendwater[MAXPRTPIP];                     // End if underwater
EXTERN Uint8           pipendbump[MAXPRTPIP];                      // End if bumped
EXTERN Uint8           pipendground[MAXPRTPIP];                    // End if on ground
EXTERN Uint8           pipendwall[MAXPRTPIP];                      // End if hit a wall
EXTERN Uint8           pipendlastframe[MAXPRTPIP];                 // End on last frame
EXTERN Uint16          pipdamagebase[MAXPRTPIP];                   // Damage
EXTERN Uint16          pipdamagerand[MAXPRTPIP];                   // Damage
EXTERN Uint8           pipdamagetype[MAXPRTPIP];                   // Damage type
EXTERN Sint16            pipfacingbase[MAXPRTPIP];                   // Facing
EXTERN Uint16          pipfacingadd[MAXPRTPIP];                    // Facing
EXTERN Uint16          pipfacingrand[MAXPRTPIP];                   // Facing
EXTERN Sint16            pipxyspacingbase[MAXPRTPIP];                // Spacing
EXTERN Uint16          pipxyspacingrand[MAXPRTPIP];                // Spacing
EXTERN Sint16            pipzspacingbase[MAXPRTPIP];                 // Altitude
EXTERN Uint16          pipzspacingrand[MAXPRTPIP];                 // Altitude
EXTERN Sint8             pipxyvelbase[MAXPRTPIP];                    // Shot velocity
EXTERN Uint8           pipxyvelrand[MAXPRTPIP];                    // Shot velocity
EXTERN Sint8             pipzvelbase[MAXPRTPIP];                     // Up velocity
EXTERN Uint8           pipzvelrand[MAXPRTPIP];                     // Up velocity
EXTERN Uint16          pipcontspawntime[MAXPRTPIP];                // Spawn timer
EXTERN Uint8           pipcontspawnamount[MAXPRTPIP];              // Spawn amount
EXTERN Uint16          pipcontspawnfacingadd[MAXPRTPIP];           // Spawn in circle
EXTERN Uint16          pipcontspawnpip[MAXPRTPIP];                 // Spawn type ( local )
EXTERN Uint8           pipendspawnamount[MAXPRTPIP];               // Spawn amount
EXTERN Uint16          pipendspawnfacingadd[MAXPRTPIP];            // Spawn in circle
EXTERN Uint8           pipendspawnpip[MAXPRTPIP];                  // Spawn type ( local )
EXTERN Uint8           pipbumpspawnamount[MAXPRTPIP];              // Spawn amount
EXTERN Uint8           pipbumpspawnpip[MAXPRTPIP];                 // Spawn type ( global )
EXTERN Uint8           pipdynalightmode[MAXPRTPIP];                // Dynamic light on?
EXTERN float                   pipdynalevel[MAXPRTPIP];                    // Intensity
EXTERN Uint16          pipdynafalloff[MAXPRTPIP];                  // Falloff
EXTERN Uint16          pipdazetime[MAXPRTPIP];                     // Daze
EXTERN Uint16          pipgrogtime[MAXPRTPIP];                     // Drunkeness
EXTERN Sint8             pipsoundspawn[MAXPRTPIP];                   // Beginning sound
EXTERN Sint8             pipsoundend[MAXPRTPIP];                     // Ending sound
EXTERN Sint8             pipsoundfloor[MAXPRTPIP];                   // Floor sound
EXTERN Sint8             pipsoundwall[MAXPRTPIP];                    // Ricochet sound
EXTERN bool_t          pipfriendlyfire[MAXPRTPIP];                 // Friendly fire
EXTERN bool_t          piprotatetoface[MAXPRTPIP];                 // Arrows/Missiles
EXTERN bool_t          pipcausepancake[MAXPRTPIP];                       // Cause pancake?
EXTERN bool_t          pipcauseknockback[MAXPRTPIP];                       // Cause knockback?
EXTERN bool_t          pipnewtargetonspawn[MAXPRTPIP];             // Get new target?
EXTERN bool_t          piphoming[MAXPRTPIP];                       // Homing?
EXTERN Uint16          piptargetangle[MAXPRTPIP];                  // To find target
EXTERN float                   piphomingaccel[MAXPRTPIP];                  // Acceleration rate
EXTERN float                   piphomingfriction[MAXPRTPIP];               // Deceleration rate
EXTERN float                   pipdynalightleveladd[MAXPRTPIP];            // Dyna light changes
EXTERN float                   pipdynalightfalloffadd[MAXPRTPIP];          //
EXTERN bool_t          piptargetcaster[MAXPRTPIP];                 // Target caster?
EXTERN bool_t          pipspawnenchant[MAXPRTPIP];                 // Spawn enchant?
EXTERN bool_t          pipneedtarget[MAXPRTPIP];                   // Need a target?
EXTERN bool_t          piponlydamagefriendly[MAXPRTPIP];           // Only friends?
EXTERN bool_t           piphateonly[MAXPRTPIP];						// Only enemies? !!BAD NOT DONE!!
EXTERN Uint8           pipstartontarget[MAXPRTPIP];                // Start on target?
EXTERN int                     pipzaimspd[MAXPRTPIP];                      // [ZSPD] For Z aiming
EXTERN Uint16          pipdamfx[MAXPRTPIP];                        // Damage effects
EXTERN bool_t                  pipallowpush[MAXPRTPIP];                    //Allow particle to push characters around
EXTERN bool_t                  pipintdamagebonus[MAXPRTPIP];               //Add intelligence as damage bonus
EXTERN bool_t                  pipwisdamagebonus[MAXPRTPIP];               //Add wisdom as damage bonus
EXTERN float                     pipmanadrain[MAXPRTPIP];                      //Reduce target mana by this amount

// The ID number for host searches
// {A0F72DE8-2C17-11d3-B7FE-444553540000}
/* PORT
DEFINE_GUID(NETWORKID, 0xa0f72de8, 0x2c17, 0x11d3, 0xb7, 0xfe, 0x44, 0x45, 0x53, 0x54, 0x0, 0x0);
*/
#define MAXSERVICE 16
#define NETNAMESIZE 16
#define MAXSESSION 16
#define MAXNETPLAYER 8
EXTERN Uint32      randsave;         //Used in network timer
EXTERN int                     networkservice;
EXTERN int                     numservice  EQ(0);                             // How many we found
EXTERN char                    netservicename[MAXSERVICE][NETNAMESIZE];    // Names of services
EXTERN int                     numsession  EQ(0);                             // How many we found
EXTERN char                    netsessionname[MAXSESSION][NETNAMESIZE];    // Names of sessions
EXTERN int                     numplayer  EQ(0);                              // How many we found
EXTERN char                    netplayername[MAXNETPLAYER][NETNAMESIZE];   // Names of machines
/* PORT
LPVOID                  netlpconnectionbuffer[MAXSERVICE];          // Location of service info
LPGUID                  netlpsessionguid[MAXSESSION];               // GUID for joining
DPID                    netplayerid[MAXNETPLAYER];                  // Player ID
DPID                    selfid;                                     // Player ID
*/


EXTERN char *globalname  EQ(NULL);  // For debuggin' goto_colon
EXTERN char *globalparsename  EQ(NULL); // The SCRIPT.TXT filename
EXTERN FILE *globalparseerr  EQ(NULL); // For debuggin' scripted AI
EXTERN FILE *globalnetworkerr  EQ(NULL); // For debuggin' network


EXTERN float           indextoenvirox[MD2LIGHTINDICES];                    // Environment map
EXTERN float           lighttoenviroy[256];                                // Environment map
EXTERN Uint32          lighttospek[MAXSPEKLEVEL][256];                     //


EXTERN float           hillslide  EQ(1.00);                                   //
EXTERN float           slippyfriction  EQ(1.00);  //1.05 for Chevron          // Friction
EXTERN float           airfriction  EQ(.95);                                  //
EXTERN float           waterfriction  EQ(.85);                                //
EXTERN float           noslipfriction  EQ(0.95);                              //
EXTERN float           platstick  EQ(.040);                                   //
EXTERN float           gravity  EQ((float) - 1.0);                            // Gravitational accel
EXTERN int             damagetileamount  EQ(256);                             // Amount of damage
EXTERN Uint8   damagetiletype  EQ(DAMAGEFIRE);                        // Type of damage


EXTERN char            cFrameName[16];                                     // MD2 Frame Name


EXTERN Uint16  globesttarget;                                      // For find_target
EXTERN Uint16  globestangle;                                       //
EXTERN Uint16  glouseangle;                                        //
EXTERN int             globestdistance;


EXTERN Uint32    numfanblock  EQ(0);                                    // Number of collision areas
EXTERN Uint16  meshbumplistchr[MAXMESHFAN/16];                     // For character collisions
EXTERN Uint16  meshbumplistchrnum[MAXMESHFAN/16];                  // Number on the block
EXTERN Uint16  meshbumplistprt[MAXMESHFAN/16];                     // For particle collisions
EXTERN Uint16  meshbumplistprtnum[MAXMESHFAN/16];                  // Number on the block
EXTERN bool_t  meshexploremode  EQ(bfalse);                            // Explore mode?
EXTERN int             meshsizex;                                          // Size in fansquares
EXTERN int             meshsizey;                                          //
EXTERN float           meshedgex;                                          // Limits !!!BAD!!!
EXTERN float           meshedgey;                                          //
EXTERN Uint16  meshlasttexture;                                    // Last texture used
EXTERN Uint8   meshtype[MAXMESHFAN];                               // Command type
EXTERN Uint8   meshfx[MAXMESHFAN];                                 // Special effects flags
EXTERN Uint8   meshtwist[MAXMESHFAN];                              //
EXTERN Uint8   meshinrenderlist[MAXMESHFAN];                       //
EXTERN Uint16  meshtile[MAXMESHFAN];                               // Get texture from this
EXTERN Uint32    meshvrtstart[MAXMESHFAN];                           // Which vertex to start at
EXTERN Uint32    meshblockstart[(MAXMESHSIZEY/4)+1];
EXTERN Uint32    meshfanstart[MAXMESHSIZEY];                         // Which fan to start a row with
//float           meshvrtx[MAXTOTALMESHVERTICES];                     // Vertex position
//float           meshvrty[MAXTOTALMESHVERTICES];                     //
//float           meshvrtz[MAXTOTALMESHVERTICES];                     // Vertex elevation
//Uint8   meshvrta[MAXTOTALMESHVERTICES];                     // Vertex starting light
//Uint8   meshvrtl[MAXTOTALMESHVERTICES];                     // Vertex light
EXTERN float *floatmemory;                                                 // For malloc
EXTERN float*          meshvrtx;                                           // Vertex position
EXTERN float*          meshvrty;                                           //
EXTERN float*          meshvrtz;                                           // Vertex elevation
EXTERN Uint8*  meshvrta;                                           // Vertex base light
EXTERN Uint8*  meshvrtl;                                           // Vertex light
EXTERN Uint8   meshcommands[MAXMESHTYPE];                          // Number of commands
EXTERN Uint8   meshcommandsize[MAXMESHTYPE][MAXMESHCOMMAND];       // Entries in each command
EXTERN Uint16  meshcommandvrt[MAXMESHTYPE][MAXMESHCOMMANDENTRIES]; // Fansquare vertex list
EXTERN Uint8   meshcommandnumvertices[MAXMESHTYPE];                // Number of vertices
EXTERN float           meshcommandu[MAXMESHTYPE][MAXMESHVERTICES];         // Vertex texture posi
EXTERN float           meshcommandv[MAXMESHTYPE][MAXMESHVERTICES];         //
EXTERN float           meshtileoffu[MAXTILETYPE];                          // Tile texture offset
EXTERN float           meshtileoffv[MAXTILETYPE];                          //
EXTERN int             nummeshrenderlist;                                  // Number to render, total
EXTERN int             nummeshrenderlistref;                               // ..., reflective
EXTERN int             nummeshrenderlistsha;                               // ..., shadow
EXTERN Uint32    meshrenderlist[MAXMESHRENDER];                      // List of which to render, total
EXTERN Uint32    meshrenderlistref[MAXMESHRENDER];                   // ..., reflective
EXTERN Uint32    meshrenderlistsha[MAXMESHRENDER];                   // ..., shadow


EXTERN Uint8   asciitofont[256];                                   // Conversion table


// Display messages
EXTERN Uint16  msgtimechange EQ(0);                                    //
EXTERN Uint16  msgstart EQ(0);                                         // The message queue
EXTERN Sint16    msgtime[MAXMESSAGE];                                //
EXTERN char            msgtextdisplay[MAXMESSAGE][MESSAGESIZE];            // The displayed text
// Message files
EXTERN Uint16  msgtotal EQ(0);                                         // The number of messages
EXTERN Uint32    msgtotalindex EQ(0);                                    // Where to put letter
EXTERN Uint32    msgindex[MAXTOTALMESSAGE];                          // Where it is
EXTERN char            msgtext[MESSAGEBUFFERSIZE];                         // The text buffer



// My lil' random number table
#define MAXRAND 4096
EXTERN Uint16 randie[MAXRAND];
EXTERN Uint16 randindex;
#define RANDIE randie[randindex];  randindex=(randindex+1)&(MAXRAND-1)


#define MAXENDTEXT 1024
EXTERN char generictext[80];         // Use for whatever purpose
EXTERN char endtext[MAXENDTEXT];     // The end-module text
EXTERN int endtextwrite;


// This is id's normal table for computing light values
#ifdef DECLARE_GLOBALS
float md2normals[MD2LIGHTINDICES][3] =
{{ -0.5257, 0.0000, 0.8507}, { -0.4429, 0.2389, 0.8642}, { -0.2952, 0.0000, 0.9554},
  { -0.3090, 0.5000, 0.8090}, { -0.1625, 0.2629, 0.9511}, {0.0000, 0.0000, 1.0000},
  {0.0000, 0.8507, 0.5257}, { -0.1476, 0.7166, 0.6817}, {0.1476, 0.7166, 0.6817},
  {0.0000, 0.5257, 0.8507}, {0.3090, 0.5000, 0.8090}, {0.5257, 0.0000, 0.8507},
  {0.2952, 0.0000, 0.9554}, {0.4429, 0.2389, 0.8642}, {0.1625, 0.2629, 0.9511},
  { -0.6817, 0.1476, 0.7166}, { -0.8090, 0.3090, 0.5000}, { -0.5878, 0.4253, 0.6882},
  { -0.8507, 0.5257, 0.0000}, { -0.8642, 0.4429, 0.2389}, { -0.7166, 0.6817, 0.1476},
  { -0.6882, 0.5878, 0.4253}, { -0.5000, 0.8090, 0.3090}, { -0.2389, 0.8642, 0.4429},
  { -0.4253, 0.6882, 0.5878}, { -0.7166, 0.6817, -0.1476}, { -0.5000, 0.8090, -0.3090},
  { -0.5257, 0.8507, 0.0000}, {0.0000, 0.8507, -0.5257}, { -0.2389, 0.8642, -0.4429},
  {0.0000, 0.9554, -0.2952}, { -0.2629, 0.9511, -0.1625}, {0.0000, 1.0000, 0.0000},
  {0.0000, 0.9554, 0.2952}, { -0.2629, 0.9511, 0.1625}, {0.2389, 0.8642, 0.4429},
  {0.2629, 0.9511, 0.1625}, {0.5000, 0.8090, 0.3090}, {0.2389, 0.8642, -0.4429},
  {0.2629, 0.9511, -0.1625}, {0.5000, 0.8090, -0.3090}, {0.8507, 0.5257, 0.0000},
  {0.7166, 0.6817, 0.1476}, {0.7166, 0.6817, -0.1476}, {0.5257, 0.8507, 0.0000},
  {0.4253, 0.6882, 0.5878}, {0.8642, 0.4429, 0.2389}, {0.6882, 0.5878, 0.4253},
  {0.8090, 0.3090, 0.5000}, {0.6817, 0.1476, 0.7166}, {0.5878, 0.4253, 0.6882},
  {0.9554, 0.2952, 0.0000}, {1.0000, 0.0000, 0.0000}, {0.9511, 0.1625, 0.2629},
  {0.8507, -0.5257, 0.0000}, {0.9554, -0.2952, 0.0000}, {0.8642, -0.4429, 0.2389},
  {0.9511, -0.1625, 0.2629}, {0.8090, -0.3090, 0.5000}, {0.6817, -0.1476, 0.7166},
  {0.8507, 0.0000, 0.5257}, {0.8642, 0.4429, -0.2389}, {0.8090, 0.3090, -0.5000},
  {0.9511, 0.1625, -0.2629}, {0.5257, 0.0000, -0.8507}, {0.6817, 0.1476, -0.7166},
  {0.6817, -0.1476, -0.7166}, {0.8507, 0.0000, -0.5257}, {0.8090, -0.3090, -0.5000},
  {0.8642, -0.4429, -0.2389}, {0.9511, -0.1625, -0.2629}, {0.1476, 0.7166, -0.6817},
  {0.3090, 0.5000, -0.8090}, {0.4253, 0.6882, -0.5878}, {0.4429, 0.2389, -0.8642},
  {0.5878, 0.4253, -0.6882}, {0.6882, 0.5878, -0.4253}, { -0.1476, 0.7166, -0.6817},
  { -0.3090, 0.5000, -0.8090}, {0.0000, 0.5257, -0.8507}, { -0.5257, 0.0000, -0.8507},
  { -0.4429, 0.2389, -0.8642}, { -0.2952, 0.0000, -0.9554}, { -0.1625, 0.2629, -0.9511},
  {0.0000, 0.0000, -1.0000}, {0.2952, 0.0000, -0.9554}, {0.1625, 0.2629, -0.9511},
  { -0.4429, -0.2389, -0.8642}, { -0.3090, -0.5000, -0.8090}, { -0.1625, -0.2629, -0.9511},
  {0.0000, -0.8507, -0.5257}, { -0.1476, -0.7166, -0.6817}, {0.1476, -0.7166, -0.6817},
  {0.0000, -0.5257, -0.8507}, {0.3090, -0.5000, -0.8090}, {0.4429, -0.2389, -0.8642},
  {0.1625, -0.2629, -0.9511}, {0.2389, -0.8642, -0.4429}, {0.5000, -0.8090, -0.3090},
  {0.4253, -0.6882, -0.5878}, {0.7166, -0.6817, -0.1476}, {0.6882, -0.5878, -0.4253},
  {0.5878, -0.4253, -0.6882}, {0.0000, -0.9554, -0.2952}, {0.0000, -1.0000, 0.0000},
  {0.2629, -0.9511, -0.1625}, {0.0000, -0.8507, 0.5257}, {0.0000, -0.9554, 0.2952},
  {0.2389, -0.8642, 0.4429}, {0.2629, -0.9511, 0.1625}, {0.5000, -0.8090, 0.3090},
  {0.7166, -0.6817, 0.1476}, {0.5257, -0.8507, 0.0000}, { -0.2389, -0.8642, -0.4429},
  { -0.5000, -0.8090, -0.3090}, { -0.2629, -0.9511, -0.1625}, { -0.8507, -0.5257, 0.0000},
  { -0.7166, -0.6817, -0.1476}, { -0.7166, -0.6817, 0.1476}, { -0.5257, -0.8507, 0.0000},
  { -0.5000, -0.8090, 0.3090}, { -0.2389, -0.8642, 0.4429}, { -0.2629, -0.9511, 0.1625},
  { -0.8642, -0.4429, 0.2389}, { -0.8090, -0.3090, 0.5000}, { -0.6882, -0.5878, 0.4253},
  { -0.6817, -0.1476, 0.7166}, { -0.4429, -0.2389, 0.8642}, { -0.5878, -0.4253, 0.6882},
  { -0.3090, -0.5000, 0.8090}, { -0.1476, -0.7166, 0.6817}, { -0.4253, -0.6882, 0.5878},
  { -0.1625, -0.2629, 0.9511}, {0.4429, -0.2389, 0.8642}, {0.1625, -0.2629, 0.9511},
  {0.3090, -0.5000, 0.8090}, {0.1476, -0.7166, 0.6817}, {0.0000, -0.5257, 0.8507},
  {0.4253, -0.6882, 0.5878}, {0.5878, -0.4253, 0.6882}, {0.6882, -0.5878, 0.4253},
  { -0.9554, 0.2952, 0.0000}, { -0.9511, 0.1625, 0.2629}, { -1.0000, 0.0000, 0.0000},
  { -0.8507, 0.0000, 0.5257}, { -0.9554, -0.2952, 0.0000}, { -0.9511, -0.1625, 0.2629},
  { -0.8642, 0.4429, -0.2389}, { -0.9511, 0.1625, -0.2629}, { -0.8090, 0.3090, -0.5000},
  { -0.8642, -0.4429, -0.2389}, { -0.9511, -0.1625, -0.2629}, { -0.8090, -0.3090, -0.5000},
  { -0.6817, 0.1476, -0.7166}, { -0.6817, -0.1476, -0.7166}, { -0.8507, 0.0000, -0.5257},
  { -0.6882, 0.5878, -0.4253}, { -0.5878, 0.4253, -0.6882}, { -0.4253, 0.6882, -0.5878},
  { -0.4253, -0.6882, -0.5878}, { -0.5878, -0.4253, -0.6882}, { -0.6882, -0.5878, -0.4253},
  {0, 0, 0}  // Spikey mace
};
#else
EXTERN float md2normals[MD2LIGHTINDICES][3];
#endif

// This is for random naming
EXTERN Uint16          numchop  EQ(0);                // The number of name parts
EXTERN Uint32            chopwrite  EQ(0);              // The data pointer
EXTERN char                    chopdata[CHOPDATACHUNK];    // The name parts
EXTERN Uint16          chopstart[MAXCHOP];         // The first character of each part
EXTERN Uint16          capsectionsize[MAXMODEL][MAXSECTION];   // Number of choices, 0
EXTERN Uint16          capsectionstart[MAXMODEL][MAXSECTION];  //
EXTERN char                    namingnames[MAXCAPNAMESIZE];// The name returned by the function



// These are for the AI script loading/parsing routines
extern int                     iNumAis;
#define HAS_BITS(XX,YY) (0 != ((XX)&(YY)))

#define ALERTIFSPAWNED                      (1<< 0)
#define ALERTIFHITVULNERABLE                (1<< 1)
#define ALERTIFATWAYPOINT                   (1<< 2)
#define ALERTIFATLASTWAYPOINT               (1<< 3)
#define ALERTIFATTACKED                     (1<< 4)
#define ALERTIFBUMPED                       (1<< 5)
#define ALERTIFORDERED                      (1<< 6)
#define ALERTIFCALLEDFORHELP                (1<< 7)
#define ALERTIFKILLED                       (1<< 8)
#define ALERTIFTARGETKILLED                 (1<< 9)
#define ALERTIFDROPPED                      (1<<10)
#define ALERTIFGRABBED                      (1<<11)
#define ALERTIFREAFFIRMED                   (1<<12)
#define ALERTIFLEADERKILLED                 (1<<13)
#define ALERTIFUSED                         (1<<14)
#define ALERTIFCLEANEDUP                    (1<<15)
#define ALERTIFSCOREDAHIT                   (1<<16)
#define ALERTIFHEALED                       (1<<17)
#define ALERTIFDISAFFIRMED                  (1<<18)
#define ALERTIFCHANGED                      (1<<19)
#define ALERTIFINWATER                      (1<<20)
#define ALERTIFBORED                        (1<<21)
#define ALERTIFTOOMUCHBAGGAGE               (1<<22)
#define ALERTIFGROGGED                      (1<<23)
#define ALERTIFDAZED                        (1<<24)
#define ALERTIFHITGROUND                    (1<<25)
#define ALERTIFNOTDROPPED                   (1<<26)
#define ALERTIFBLOCKED                      (1<<27)
#define ALERTIFTHROWN                       (1<<28)
#define ALERTIFCRUSHED                      (1<<29)
#define ALERTIFNOTPUTAWAY                   (1<<30)
#define ALERTIFTAKENOUT                     (1<<31)

#define FIFSPAWNED                          0   // Scripted AI functions (v0.10)
#define FIFTIMEOUT                          1   //
#define FIFATWAYPOINT                       2   //
#define FIFATLASTWAYPOINT                   3   //
#define FIFATTACKED                         4   //
#define FIFBUMPED                           5   //
#define FIFORDERED                          6   //
#define FIFCALLEDFORHELP                    7   //
#define FSETCONTENT                         8   //
#define FIFKILLED                           9   //
#define FIFTARGETKILLED                     10  //
#define FCLEARWAYPOINTS                     11  //
#define FADDWAYPOINT                        12  //
#define FFINDPATH                           13  //
#define FCOMPASS                            14  //
#define FGETTARGETARMORPRICE                15  //
#define FSETTIME                            16  //
#define FGETCONTENT                         17  //
#define FJOINTARGETTEAM                     18  //
#define FSETTARGETTONEARBYENEMY             19  //
#define FSETTARGETTOTARGETLEFTHAND          20  //
#define FSETTARGETTOTARGETRIGHTHAND         21  //
#define FSETTARGETTOWHOEVERATTACKED         22  //
#define FSETTARGETTOWHOEVERBUMPED           23  //
#define FSETTARGETTOWHOEVERCALLEDFORHELP    24  //
#define FSETTARGETTOOLDTARGET               25  //
#define FSETTURNMODETOVELOCITY              26  //
#define FSETTURNMODETOWATCH                 27  //
#define FSETTURNMODETOSPIN                  28  //
#define FSETBUMPHEIGHT                      29  //
#define FIFTARGETHASID                      30  //
#define FIFTARGETHASITEMID                  31  //
#define FIFTARGETHOLDINGITEMID              32  //
#define FIFTARGETHASSKILLID                 33  //
#define FELSE                               34  //
#define FRUN                                35  //
#define FWALK                               36  //
#define FSNEAK                              37  //
#define FDOACTION                           38  //
#define FKEEPACTION                         39  //
#define FISSUEORDER                         40  //
#define FDROPWEAPONS                        41  //
#define FTARGETDOACTION                     42  //
#define FOPENPASSAGE                        43  //
#define FCLOSEPASSAGE                       44  //
#define FIFPASSAGEOPEN                      45  //
#define FGOPOOF                             46  //
#define FCOSTTARGETITEMID                   47  //
#define FDOACTIONOVERRIDE                   48  //
#define FIFHEALED                           49  //
#define FSENDMESSAGE                        50  //
#define FCALLFORHELP                        51  //
#define FADDIDSZ                            52  //
#define FEND                                53  //
#define FSETSTATE                           54  // Scripted AI functions (v0.20)
#define FGETSTATE                           55  //
#define FIFSTATEIS                          56  //
#define FIFTARGETCANOPENSTUFF               57  // Scripted AI functions (v0.30)
#define FIFGRABBED                          58  //
#define FIFDROPPED                          59  //
#define FSETTARGETTOWHOEVERISHOLDING        60  //
#define FDAMAGETARGET                       61  //
#define FIFXISLESSTHANY                     62  //
#define FSETWEATHERTIME                     63  // Scripted AI functions (v0.40)
#define FGETBUMPHEIGHT                      64  //
#define FIFREAFFIRMED                       65  //
#define FUNKEEPACTION                       66  //
#define FIFTARGETISONOTHERTEAM              67  //
#define FIFTARGETISONHATEDTEAM              68  // Scripted AI functions (v0.50)
#define FPRESSLATCHBUTTON                   69  //
#define FSETTARGETTOTARGETOFLEADER          70  //
#define FIFLEADERKILLED                     71  //
#define FBECOMELEADER                       72  //
#define FCHANGETARGETARMOR                  73  // Scripted AI functions (v0.60)
#define FGIVEMONEYTOTARGET                  74  //
#define FDROPKEYS                           75  //
#define FIFLEADERISALIVE                    76  //
#define FIFTARGETISOLDTARGET                77  //
#define FSETTARGETTOLEADER                  78  //
#define FSPAWNCHARACTER                     79  //
#define FRESPAWNCHARACTER                   80  //
#define FCHANGETILE                         81  //
#define FIFUSED                             82  //
#define FDROPMONEY                          83  //
#define FSETOLDTARGET                       84  //
#define FDETACHFROMHOLDER                   85  //
#define FIFTARGETHASVULNERABILITYID         86  //
#define FCLEANUP                            87  //
#define FIFCLEANEDUP                        88  //
#define FIFSITTING                          89  //
#define FIFTARGETISHURT                     90  //
#define FIFTARGETISAPLAYER                  91  //
#define FPLAYSOUND                          92  //
#define FSPAWNPARTICLE                      93  //
#define FIFTARGETISALIVE                    94  //
#define FSTOP                               95  //
#define FDISAFFIRMCHARACTER                 96  //
#define FREAFFIRMCHARACTER                  97  //
#define FIFTARGETISSELF                     98  //
#define FIFTARGETISMALE                     99  //
#define FIFTARGETISFEMALE                   100 //
#define FSETTARGETTOSELF                    101 // Scripted AI functions (v0.70)
#define FSETTARGETTORIDER                   102 //
#define FGETATTACKTURN                      103 //
#define FGETDAMAGETYPE                      104 //
#define FBECOMESPELL                        105 //
#define FBECOMESPELLBOOK                    106 //
#define FIFSCOREDAHIT                       107 //
#define FIFDISAFFIRMED                      108 //
#define FTRANSLATEORDER                     109 //
#define FSETTARGETTOWHOEVERWASHIT           110 //
#define FSETTARGETTOWIDEENEMY               111 //
#define FIFCHANGED                          112 //
#define FIFINWATER                          113 //
#define FIFBORED                            114 //
#define FIFTOOMUCHBAGGAGE                   115 //
#define FIFGROGGED                          116 //
#define FIFDAZED                            117 //
#define FIFTARGETHASSPECIALID               118 //
#define FPRESSTARGETLATCHBUTTON             119 //
#define FIFINVISIBLE                        120 //
#define FIFARMORIS                          121 //
#define FGETTARGETGROGTIME                  122 //
#define FGETTARGETDAZETIME                  123 //
#define FSETDAMAGETYPE                      124 //
#define FSETWATERLEVEL                      125 //
#define FENCHANTTARGET                      126 //
#define FENCHANTCHILD                       127 //
#define FTELEPORTTARGET                     128 //
#define FGIVEEXPERIENCETOTARGET             129 //
#define FINCREASEAMMO                       130 //
#define FUNKURSETARGET                      131 //
#define FGIVEEXPERIENCETOTARGETTEAM         132 //
#define FIFUNARMED                          133 //
#define FRESTOCKTARGETAMMOIDALL             134 //
#define FRESTOCKTARGETAMMOIDFIRST           135 //
#define FFLASHTARGET                        136 //
#define FSETREDSHIFT                        137 //
#define FSETGREENSHIFT                      138 //
#define FSETBLUESHIFT                       139 //
#define FSETLIGHT                           140 //
#define FSETALPHA                           141 //
#define FIFHITFROMBEHIND                    142 //
#define FIFHITFROMFRONT                     143 //
#define FIFHITFROMLEFT                      144 //
#define FIFHITFROMRIGHT                     145 //
#define FIFTARGETISONSAMETEAM               146 //
#define FKILLTARGET                         147 //
#define FUNDOENCHANT                        148 //
#define FGETWATERLEVEL                      149 //
#define FCOSTTARGETMANA                     150 //
#define FIFTARGETHASANYID                   151 //
#define FSETBUMPSIZE                        152 //
#define FIFNOTDROPPED                       153 //
#define FIFYISLESSTHANX                     154 //
#define FSETFLYHEIGHT                       155 //
#define FIFBLOCKED                          156 //
#define FIFTARGETISDEFENDING                157 //
#define FIFTARGETISATTACKING                158 //
#define FIFSTATEIS0                         159 //
#define FIFSTATEIS1                         160 //
#define FIFSTATEIS2                         161 //
#define FIFSTATEIS3                         162 //
#define FIFSTATEIS4                         163 //
#define FIFSTATEIS5                         164 //
#define FIFSTATEIS6                         165 //
#define FIFSTATEIS7                         166 //
#define FIFCONTENTIS                        167 //
#define FSETTURNMODETOWATCHTARGET           168 //
#define FIFSTATEISNOT                       169 //
#define FIFXISEQUALTOY                      170 //
#define FDEBUGMESSAGE                       171 //
#define FBLACKTARGET                        172 // Scripted AI functions (v0.80)
#define FSENDMESSAGENEAR                    173 //
#define FIFHITGROUND                        174 //
#define FIFNAMEISKNOWN                      175 //
#define FIFUSAGEISKNOWN                     176 //
#define FIFHOLDINGITEMID                    177 //
#define FIFHOLDINGRANGEDWEAPON              178 //
#define FIFHOLDINGMELEEWEAPON               179 //
#define FIFHOLDINGSHIELD                    180 //
#define FIFKURSED                           181 //
#define FIFTARGETISKURSED                   182 //
#define FIFTARGETISDRESSEDUP                183 //
#define FIFOVERWATER                        184 //
#define FIFTHROWN                           185 //
#define FMAKENAMEKNOWN                      186 //
#define FMAKEUSAGEKNOWN                     187 //
#define FSTOPTARGETMOVEMENT                 188 //
#define FSETXY                              189 //
#define FGETXY                              190 //
#define FADDXY                              191 //
#define FMAKEAMMOKNOWN                      192 //
#define FSPAWNATTACHEDPARTICLE              193 //
#define FSPAWNEXACTPARTICLE                 194 //
#define FACCELERATETARGET                   195 //
#define FIFDISTANCEISMORETHANTURN           196 //
#define FIFCRUSHED                          197 //
#define FMAKECRUSHVALID                     198 //
#define FSETTARGETTOLOWESTTARGET            199 //
#define FIFNOTPUTAWAY                       200 //
#define FIFTAKENOUT                         201 //
#define FIFAMMOOUT                          202 //
#define FPLAYSOUNDLOOPED                    203 //
#define FSTOPSOUND                          204 //
#define FHEALSELF                           205 //
#define FEQUIP                              206 //
#define FIFTARGETHASITEMIDEQUIPPED          207 //
#define FSETOWNERTOTARGET                   208 //
#define FSETTARGETTOOWNER                   209 //
#define FSETFRAME                           210 //
#define FBREAKPASSAGE                       211 //
#define FSETRELOADTIME                      212 //
#define FSETTARGETTOWIDEBLAHID              213 //
#define FPOOFTARGET                         214 //
#define FCHILDDOACTIONOVERRIDE              215 //
#define FSPAWNPOOF                          216 //
#define FSETSPEEDPERCENT                    217 //
#define FSETCHILDSTATE                      218 //
#define FSPAWNATTACHEDSIZEDPARTICLE         219 //
#define FCHANGEARMOR                        220 //
#define FSHOWTIMER                          221 //
#define FIFFACINGTARGET                     222 //
#define FPLAYSOUNDVOLUME                    223 //
#define FSPAWNATTACHEDFACEDPARTICLE         224 //
#define FIFSTATEISODD                       225 //
#define FSETTARGETTODISTANTENEMY            226 //
#define FTELEPORT                           227 //
#define FGIVESTRENGTHTOTARGET               228 //
#define FGIVEWISDOMTOTARGET                 229 //
#define FGIVEINTELLIGENCETOTARGET           230 //
#define FGIVEDEXTERITYTOTARGET              231 //
#define FGIVELIFETOTARGET                   232 //
#define FGIVEMANATOTARGET                   233 //
#define FSHOWMAP                            234 //
#define FSHOWYOUAREHERE                     235 //
#define FSHOWBLIPXY                         236 //
#define FHEALTARGET                         237 //
#define FPUMPTARGET                         238 //
#define FCOSTAMMO                           239 //
#define FMAKESIMILARNAMESKNOWN              240 //
#define FSPAWNATTACHEDHOLDERPARTICLE        241 //
#define FSETTARGETRELOADTIME                242 //
#define FSETFOGLEVEL                        243 //
#define FGETFOGLEVEL                        244 //
#define FSETFOGTAD                          245 //
#define FSETFOGBOTTOMLEVEL                  246 //
#define FGETFOGBOTTOMLEVEL                  247 //
#define FCORRECTACTIONFORHAND               248 //
#define FIFTARGETISMOUNTED                  249 //
#define FSPARKLEICON                        250 //
#define FUNSPARKLEICON                      251 //
#define FGETTILEXY                          252 //
#define FSETTILEXY                          253 //
#define FSETSHADOWSIZE                      254 //
#define FORDERTARGET                        255 //
#define FSETTARGETTOWHOEVERISINPASSAGE      256 //
#define FIFCHARACTERWASABOOK                257 //
#define FSETENCHANTBOOSTVALUES              258 // Scripted AI functions (v0.90)
#define FSPAWNCHARACTERXYZ                  259 //
#define FSPAWNEXACTCHARACTERXYZ             260 //
#define FCHANGETARGETCLASS                  261 //
#define FPLAYFULLSOUND                      262 //
#define FSPAWNEXACTCHASEPARTICLE            263 //
#define FCREATEORDER                        264 //
#define FORDERSPECIALID                     265 //
#define FUNKURSETARGETINVENTORY             266 //
#define FIFTARGETISSNEAKING                 267 //
#define FDROPITEMS                          268 //
#define FRESPAWNTARGET                      269 //
#define FTARGETDOACTIONSETFRAME             270 //
#define FIFTARGETCANSEEINVISIBLE            271 //
#define FSETTARGETTONEARESTBLAHID           272 //
#define FSETTARGETTONEARESTENEMY            273 //
#define FSETTARGETTONEARESTFRIEND           274 //
#define FSETTARGETTONEARESTLIFEFORM         275 //
#define FFLASHPASSAGE                       276 //
#define FFINDTILEINPASSAGE                  277 //
#define FIFHELDINLEFTHAND                   278 //
#define FNOTANITEM                          279 //
#define FSETCHILDAMMO                       280 //
#define FIFHITVULNERABLE                    281 //
#define FIFTARGETISFLYING                   282 //
#define FIDENTIFYTARGET                     283 //
#define FBEATMODULE                         284 //
#define FENDMODULE                          285 //
#define FDISABLEEXPORT                      286 //
#define FENABLEEXPORT                       287 //
#define FGETTARGETSTATE                     288 //
#define FIFEQUIPPED                         289 //Redone in v 0.95
#define FDROPTARGETMONEY                    290 //
#define FGETTARGETCONTENT					291 //
#define FDROPTARGETKEYS                     292 //
#define FJOINTEAM							293 //
#define FTARGETJOINTEAM                     294 //
#define FCLEARMUSICPASSAGE                  295 //Below is original code again
#define FCLEARENDMESSAGE                    296 //
#define FADDENDMESSAGE                      297 //
#define FPLAYMUSIC                          298 //
#define FSETMUSICPASSAGE                    299 //
#define FMAKECRUSHINVALID                   300 //
#define FSTOPMUSIC                          301 //
#define FFLASHVARIABLE                      302 //
#define FACCELERATEUP                       303 //
#define FFLASHVARIABLEHEIGHT                304 //
#define FSETDAMAGETIME                      305 //
#define FIFSTATEIS8                         306 //
#define FIFSTATEIS9                         307 //
#define FIFSTATEIS10                        308 //
#define FIFSTATEIS11                        309 //
#define FIFSTATEIS12                        310 //
#define FIFSTATEIS13                        311 //
#define FIFSTATEIS14                        312 //
#define FIFSTATEIS15                        313 //
#define FIFTARGETISAMOUNT                   314 //
#define FIFTARGETISAPLATFORM                315 //
#define FADDSTAT                            316 //
#define FDISENCHANTTARGET                   317 //
#define FDISENCHANTALL                      318 //
#define FSETVOLUMENEARESTTEAMMATE           319 //
#define FADDSHOPPASSAGE                     320 //
#define FTARGETPAYFORARMOR                  321 //
#define FJOINEVILTEAM                       322 //
#define FJOINNULLTEAM                       323 //
#define FJOINGOODTEAM                       324 //
#define FPITSKILL                           325 //
#define FSETTARGETTOPASSAGEID               326 //
#define FMAKENAMEUNKNOWN                    327 //
#define FSPAWNEXACTPARTICLEENDSPAWN         328 //
#define FSPAWNPOOFSPEEDSPACINGDAMAGE        329 //
#define FGIVEEXPERIENCETOGOODTEAM           330 //
#define FDONOTHING                          331 // Scripted AI functions (v0.95)
#define FGROGTARGET                         332 //
#define FDAZETARGET                         333 //
#define FADDQUEST                           334 // Scripted AI functions (v1.00)
#define FBEATQUEST                          335 //
#define FIFTARGETHASQUEST                   336 //

#define OPADD 0        // +
#define OPSUB 1        // -
#define OPAND 2        // &
#define OPSHR 3        // >
#define OPSHL 4        // <
#define OPMUL 5        // *
#define OPDIV 6        // /
#define OPMOD 7        // %

#define VARTMPX             0
#define VARTMPY             1
#define VARTMPDISTANCE      2
#define VARTMPTURN          3
#define VARTMPARGUMENT      4
#define VARRAND             5
#define VARSELFX            6
#define VARSELFY            7
#define VARSELFTURN         8
#define VARSELFCOUNTER      9
#define VARSELFORDER        10
#define VARSELFMORALE       11
#define VARSELFLIFE         12
#define VARTARGETX          13
#define VARTARGETY          14
#define VARTARGETDISTANCE   15
#define VARTARGETTURN       16
#define VARLEADERX          17
#define VARLEADERY          18
#define VARLEADERDISTANCE   19
#define VARLEADERTURN       20
#define VARGOTOX            21
#define VARGOTOY            22
#define VARGOTODISTANCE     23
#define VARTARGETTURNTO     24
#define VARPASSAGE          25
#define VARWEIGHT           26
#define VARSELFALTITUDE     27
#define VARSELFID           28
#define VARSELFHATEID       29
#define VARSELFMANA         30
#define VARTARGETSTR        31
#define VARTARGETWIS        32
#define VARTARGETINT        33
#define VARTARGETDEX        34
#define VARTARGETLIFE       35
#define VARTARGETMANA       36
#define VARTARGETLEVEL      37
#define VARTARGETSPEEDX     38
#define VARTARGETSPEEDY     39
#define VARTARGETSPEEDZ     40
#define VARSELFSPAWNX       41
#define VARSELFSPAWNY       42
#define VARSELFSTATE        43
#define VARSELFSTR          44
#define VARSELFWIS          45
#define VARSELFINT          46
#define VARSELFDEX          47
#define VARSELFMANAFLOW     48
#define VARTARGETMANAFLOW   49
#define VARSELFATTACHED     50
#define VARSWINGTURN        51
#define VARXYDISTANCE       52
#define VARSELFZ            53
#define VARTARGETALTITUDE   54
#define VARTARGETZ          55
#define VARSELFINDEX        56
#define VAROWNERX           57
#define VAROWNERY           58
#define VAROWNERTURN        59
#define VAROWNERDISTANCE    60
#define VAROWNERTURNTO      61
#define VARXYTURNTO         62
#define VARSELFMONEY        63
#define VARSELFACCEL        64
#define VARTARGETEXP        65
#define VARSELFAMMO         66
#define VARTARGETAMMO       67
#define VARTARGETMONEY      68
#define VARTARGETTURNAWAY   69
#define VARSELFLEVEL     70

EXTERN Uint16 valueoldtarget EQ(0);
EXTERN Sint32 valuetmpx EQ(0);
EXTERN Sint32 valuetmpy EQ(0);
EXTERN Uint32 valuetmpturn EQ(0);
EXTERN Sint32 valuetmpdistance EQ(0);
EXTERN Sint32 valuetmpargument EQ(0);
EXTERN Uint32 valuelastindent EQ(0);
EXTERN Sint32 valueoperationsum EQ(0);
EXTERN bool_t valuegopoof EQ(bfalse);

// This stuff is for actions
#define ACTIONDA            0
#define ACTIONDB            1
#define ACTIONDC            2
#define ACTIONDD            3
#define ACTIONUA            4
#define ACTIONUB            5
#define ACTIONUC            6
#define ACTIONUD            7
#define ACTIONTA            8
#define ACTIONTB            9
#define ACTIONTC            10
#define ACTIONTD            11
#define ACTIONCA            12
#define ACTIONCB            13
#define ACTIONCC            14
#define ACTIONCD            15
#define ACTIONSA            16
#define ACTIONSB            17
#define ACTIONSC            18
#define ACTIONSD            19
#define ACTIONBA            20
#define ACTIONBB            21
#define ACTIONBC            22
#define ACTIONBD            23
#define ACTIONLA            24
#define ACTIONLB            25
#define ACTIONLC            26
#define ACTIONLD            27
#define ACTIONXA            28
#define ACTIONXB            29
#define ACTIONXC            30
#define ACTIONXD            31
#define ACTIONFA            32
#define ACTIONFB            33
#define ACTIONFC            34
#define ACTIONFD            35
#define ACTIONPA            36
#define ACTIONPB            37
#define ACTIONPC            38
#define ACTIONPD            39
#define ACTIONEA            40
#define ACTIONEB            41
#define ACTIONRA            42
#define ACTIONZA            43
#define ACTIONZB            44
#define ACTIONZC            45
#define ACTIONZD            46
#define ACTIONWA            47
#define ACTIONWB            48
#define ACTIONWC            49
#define ACTIONWD            50
#define ACTIONJA            51
#define ACTIONJB            52
#define ACTIONJC            53
#define ACTIONHA            54
#define ACTIONHB            55
#define ACTIONHC            56
#define ACTIONHD            57
#define ACTIONKA            58
#define ACTIONKB            59
#define ACTIONKC            60
#define ACTIONKD            61
#define ACTIONMA            62
#define ACTIONMB            63
#define ACTIONMC            64
#define ACTIONMD            65
#define ACTIONME            66
#define ACTIONMF            67
#define ACTIONMG            68
#define ACTIONMH            69
#define ACTIONMI            70
#define ACTIONMJ            71
#define ACTIONMK            72
#define ACTIONML            73
#define ACTIONMM            74
#define ACTIONMN            75


// For damage/stat pair reads/writes
EXTERN int pairbase, pairrand;
EXTERN float pairfrom, pairto;


//Passages
EXTERN int numpassage;       //Number of passages in the module
EXTERN int passtlx[MAXPASS];     //Passage positions
EXTERN int passtly[MAXPASS];
EXTERN int passbrx[MAXPASS];
EXTERN int passbry[MAXPASS];
EXTERN int passagemusic[MAXPASS];    //Music track appointed to the specific passage
EXTERN Uint8 passmask[MAXPASS];
EXTERN Uint8 passopen[MAXPASS];   //Is the passage open?

// For shops
EXTERN int numshoppassage;
EXTERN Uint16 shoppassage[MAXPASS];  // The passage number
EXTERN Uint16 shopowner[MAXPASS];    // Who gets the gold?
#define NOOWNER 65535


// Status displays
EXTERN int numstat  EQ(0);
EXTERN Uint16 statlist[MAXSTAT];
EXTERN int statdelay  EQ(0);
EXTERN Uint32 particletrans  EQ(0x80);
EXTERN Uint32 antialiastrans  EQ(0xC0);


//Network Stuff
//#define CHARVEL 5.0
#define INPUTNONE   0                               //
#define INPUTMOUSE  (1<<0)                          // Input devices
#define INPUTKEY    (1<<1)                          //
#define INPUTJOYA   (1<<2)                          //
#define INPUTJOYB   (1<<3)                          //
#define MAXPLAYER   (1<<3)                          // 2 to a power...  2^3

EXTERN bool_t            plavalid[MAXPLAYER];                    // Player used?
EXTERN Uint16            plaindex[MAXPLAYER];                    // Which character?
EXTERN float             plalatchx[MAXPLAYER];                   // Local latches
EXTERN float             plalatchy[MAXPLAYER];                   //
EXTERN Uint8             plalatchbutton[MAXPLAYER];              //
EXTERN Uint8             pladevice[MAXPLAYER];                   // Input device
EXTERN int               numpla;                                 // Number of players
EXTERN int               numlocalpla;                            //
EXTERN int               numfile;                                // For network copy
EXTERN int               numfilesent;                            // For network copy
EXTERN int               numfileexpected;                        // For network copy
EXTERN int               numplayerrespond;                       //



//Sound using SDL_Mixer
EXTERN bool_t         mixeron EQ(bfalse);   //Is the SDL_Mixer loaded?
#define MAXWAVE         16        // Up to 16 waves per model
#define VOLMIN          -4000      // Minumum Volume level
#define VOLUMERATIO     7        // Volume ratio
EXTERN Mix_Chunk  *capwaveindex[MAXMODEL][MAXWAVE];    //sounds in a object
EXTERN Mix_Chunk  *globalwave[10];   //All sounds loaded into memory
EXTERN Mix_Chunk  *sound;      //Used for playing one selected sound file
EXTERN int              channel;     //Which channel the current sound is using

//Music using SDL_Mixer
#define MAXPLAYLISTLENGHT 25      //Max number of different tracks loaded into memory
EXTERN bool_t   musicinmemory EQ(bfalse); //Is the music loaded in memory?
EXTERN Mix_Music        *instrumenttosound[MAXPLAYLISTLENGHT]; //This is a specific music file loaded into memory
EXTERN int              songplaying EQ(-1);    //Current song that is playing



//Some various other stuff
EXTERN Uint8 changed;

//Key/Control input defenitions
#define MAXTAG              128                     // Number of tags in scancode.txt
#define TAGSIZE             32                      // Size of each tag
EXTERN int numscantag;
EXTERN char tagname[MAXTAG][TAGSIZE];               // Scancode names
EXTERN Uint32 tagvalue[MAXTAG];                     // Scancode values

enum control_t
{
  KEY_JUMP = 0,
  KEY_LEFT_USE,
  KEY_LEFT_GET,
  KEY_LEFT_PACK,
  KEY_RIGHT_USE,
  KEY_RIGHT_GET,
  KEY_RIGHT_PACK,
  KEY_MESSAGE,
  KEY_CAMERA_LEFT,
  KEY_CAMERA_RIGHT,
  KEY_CAMERA_IN,
  KEY_CAMERA_OUT,
  KEY_UP,
  KEY_DOWN,
  KEY_LEFT,
  KEY_RIGHT,
  MOS_JUMP,
  MOS_LEFT_USE,
  MOS_LEFT_GET,
  MOS_LEFT_PACK,
  MOS_RIGHT_USE,
  MOS_RIGHT_GET,
  MOS_RIGHT_PACK,
  MOS_CAMERA,
  JOA_JUMP,
  JOA_LEFT_USE,
  JOA_LEFT_GET,
  JOA_LEFT_PACK,
  JOA_RIGHT_USE,
  JOA_RIGHT_GET,
  JOA_RIGHT_PACK,
  JOA_CAMERA,
  JOB_JUMP,
  JOB_LEFT_USE,
  JOB_LEFT_GET,
  JOB_LEFT_PACK,
  JOB_RIGHT_USE,
  JOB_RIGHT_GET,
  JOB_RIGHT_PACK,
  JOB_CAMERA,
  MAXCONTROL
};

EXTERN Uint32 controlvalue[MAXCONTROL];             // The scancode or mask
EXTERN Uint32 controliskey[MAXCONTROL];             // Is it a key?

//AI Targeting
EXTERN Uint16 globalnearest;
EXTERN float  globaldistance;

// SDL specific declarations
EXTERN SDL_Joystick *sdljoya EQ(NULL);
EXTERN SDL_Joystick *sdljoyb EQ(NULL);
EXTERN Uint8 *sdlkeybuffer;
#define SDLKEYDOWN(k) (0 != sdlkeybuffer[k])

#undef DEBUG_ATTRIB

#if defined(DEBUG_ATTRIB) && defined(_DEBUG)
#    define ATTRIB_PUSH(TXT, BITS)    { GLint xx=0; glGetIntegerv(GL_ATTRIB_STACK_DEPTH,&xx); glPushAttrib(BITS); log_info("PUSH  ATTRIB: %s before attrib stack push. level == %d\n", TXT, xx); }
#    define ATTRIB_POP(TXT)           { GLint xx=0; glPopAttrib(); glGetIntegerv(GL_ATTRIB_STACK_DEPTH,&xx); log_info("POP   ATTRIB: %s after attrib stack pop. level == %d\n", TXT, xx); }
#    define ATTRIB_GUARD_OPEN(XX)     { glGetIntegerv(GL_ATTRIB_STACK_DEPTH,&XX); log_info("OPEN ATTRIB_GUARD: before attrib stack push. level == %d\n", XX); }
#    define ATTRIB_GUARD_CLOSE(XX,YY) { glGetIntegerv(GL_ATTRIB_STACK_DEPTH,&YY); if(XX!=YY) log_error("CLOSE ATTRIB_GUARD: after attrib stack pop. level conflict %d != %d\n", XX, YY); else log_info("CLOSE ATTRIB_GUARD: after attrib stack pop. level == %d\n", XX); }
#elif defined(_DEBUG)
#    define ATTRIB_PUSH(TXT, BITS)    glPushAttrib(BITS);
#    define ATTRIB_POP(TXT)           glPopAttrib();
#    define ATTRIB_GUARD_OPEN(XX)     { glGetIntegerv(GL_ATTRIB_STACK_DEPTH,&XX);  }
#    define ATTRIB_GUARD_CLOSE(XX,YY) { glGetIntegerv(GL_ATTRIB_STACK_DEPTH,&YY); assert(XX==YY); if(XX!=YY) log_error("CLOSE ATTRIB_GUARD: after attrib stack pop. level conflict %d != %d\n", XX, YY);  }
#else
#    define ATTRIB_PUSH(TXT, BITS)    glPushAttrib(BITS);
#    define ATTRIB_POP(TXT)           glPopAttrib();
#    define ATTRIB_GUARD_OPEN(XX)
#    define ATTRIB_GUARD_CLOSE(XX,YY)
#endif

typedef struct configurable_data_t
{
  STRING basicdat_dir;
  STRING gamedat_dir;
  STRING mnu_dir;
  STRING globalparticles_dir;
  STRING modules_dir;
  STRING music_dir;
  STRING objects_dir;
  STRING import_dir;
  STRING players_dir;

  STRING nullicon_bitmap;
  STRING keybicon_bitmap;
  STRING mousicon_bitmap;
  STRING joyaicon_bitmap;
  STRING joybicon_bitmap;

  STRING tile0_bitmap;
  STRING tile1_bitmap;
  STRING tile2_bitmap;
  STRING tile3_bitmap;
  STRING watertop_bitmap;
  STRING waterlow_bitmap;
  STRING phong_bitmap;
  STRING plan_bitmap;
  STRING blip_bitmap;
  STRING font_bitmap;
  STRING icon_bitmap;
  STRING bars_bitmap;
  STRING particle_bitmap;
  STRING title_bitmap;

  STRING menu_main_bitmap;
  STRING menu_advent_bitmap;
  STRING menu_sleepy_bitmap;
  STRING menu_gnome_bitmap;


  STRING slotused_file;
  STRING passage_file;
  STRING aicodes_file;
  STRING actions_file;
  STRING alliance_file;
  STRING fans_file;
  STRING fontdef_file;
  STRING mnu_file;
  STRING money1_file;
  STRING money5_file;
  STRING money25_file;
  STRING money100_file;
  STRING weather4_file;
  STRING weather5_file;
  STRING script_file;
  STRING ripple_file;
  STRING scancode_file;
  STRING playlist_file;
  STRING spawn_file;
  STRING wawalite_file;
  STRING defend_file;
  STRING splash_file;
  STRING mesh_file;
  STRING setup_file;
  STRING log_file;
  STRING controls_file;
  STRING data_file;
  STRING copy_file;
  STRING enchant_file;
  STRING message_file;
  STRING naming_file;
  STRING modules_file;
  STRING skin_file;
  STRING credits_file;
  STRING quest_file;

  int    uifont_points;
  int    uifont_points2;
  STRING uifont_ttf;

  //Global Sounds
  STRING coinget_sound;
  STRING defend_sound;
  STRING coinfall_sound;
  STRING lvlup_sound;

  //------------------------------------
  //Setup Variables
  //------------------------------------
  bool_t zreflect;              // Reflection z buffering?
  int    maxtotalmeshvertices;  // of vertices
  bool_t fullscreen;            // Start in CData.fullscreen?
  int    scrd;                   // Screen bit depth
  int    scrx;                 // Screen X size
  int    scry;                 // Screen Y size
  int    scrz;                  // Screen z-buffer depth ( 8 unsupported )
  int    maxmessage;    //
  bool_t messageon;           // Messages?
  int    wraptolerance;     // Status bar
  bool_t  staton;                 // Draw the status bars?
  bool_t  overlayon;          //Draw overlay?
  GLenum  perspective;        // Perspective correct textures?
  bool_t  dither;             // Dithering?
  Uint8   reffadeor;              // 255 = Don't fade reflections
  GLenum  shading;             //Gourad CData.shading?
  bool_t  antialiasing;       //Antialiasing?
  bool_t  refon;              // Reflections?
  bool_t  shaon;              // Shadows?
  int     texturefilter;       //Texture filtering?
  bool_t  wateron;             // Water overlays?
  bool_t  shasprite;          // Shadow sprites?
  bool_t  phongon;                // Do phong overlay? (Outdated?)
  bool_t  twolayerwateron;        // Two layer water?
  bool_t  overlayvalid;               // Allow large overlay?
  bool_t  backgroundvalid;            // Allow large background?
  bool_t  fogallowed;          //Draw fog? (Not implemented!)
  int  particletype;              // Particle Effects image

  bool_t  soundvalid;     //Allow playing of sound?
  bool_t  musicvalid;     // Allow music and loops?
  int     musicvolume;    //The sound volume of music
  int     soundvolume;    //Volume of sounds played
  int     maxsoundchannel;   //Max number of sounds playing at the same time
  int     buffersize;     //Buffer size set in setup.txt

  Uint8 autoturncamera;             // Type of camera control...

  bool_t  networkon;              // Try to connect?
  int     lag;                                // Lag tolerance
  STRING  nethostname;                            // Name for hosting session
  STRING  netmessagename;                         // Name for messages
  Uint8 fpson;               // FPS displayed?

  // Debug options
  SDL_GrabMode GrabMouse;
  bool_t HideMouse;
  bool_t DevMode;
  // Debug options

} CONFIG_DATA;

EXTERN bool_t                    clearson  EQ(1);               // Do we clear every time?
EXTERN bool_t                    soundon  EQ(1);                // Is the sound alive?
EXTERN bool_t                    usefaredge;                 // Far edge maps? (Outdoor)
EXTERN float					 doturntime;                 // Time for smooth turn

EXTERN STRING      CStringTmp1, CStringTmp2;
EXTERN CONFIG_DATA CData;

#endif


